<?php 
class KontrolerObnovaHesla
{
		
	function __construct($id=null)
	{
		define("__PLATNOST_TOKENU_OBNOVENI_HESLA__","1");//v hodinách
		
		
		if(isset($_POST['odeslat']))
		{
        	$this->pozadavekNaObnovu(FK::post("email"));
		}
		elseif(isset($_POST['zmenitHeslo']))
		{
			$this->zmenaHesla(FK::post("token"),FK::post("email"),FK::post("noveHeslo"),FK::post("noveHeslo2"));
		}
		elseif(FK::get("token") and FK::get("email"))
		{
			$this->formularZmenyHesla(FK::get("token"),FK::get("email"));
		}	
		
	}
	
	 
		
	
	private function pozadavekNaObnovu($email)
	{
		try 
		{
			$zakaznik = Zakaznik::vratZakaznikaDleEmailu($email);			
			$tokenNesifrovany = $zakaznik->pozadavekNaObnovuHesla();
			
		
			
			
			$mail = new PHPMailerExt();
			$sablonaTelo  = new Sablona();
			
			$sablonaTelo->nastavHlavicka(false);
			$sablonaTelo->nastavPaticka(false);
			$sablonaTelo->nastavTelo("obnovaHesla.email.tpl");
			$sablonaTelo->assign('kolekceNastaveni', Kernel::vratNastaveni());
			$sablonaTelo->assign("zakaznik",$zakaznik);
			$sablonaTelo->assign("tokenNesifrovany",$tokenNesifrovany);		
			$telo = $sablonaTelo->fetch();
			
			$mail->From     = Kernel::vratNastaveni()->vrat("organizaceEmail")->vratHodnota();
			$mail->FromName = Kernel::vratNastaveni()->vrat("organizaceNazev")->vratHodnota();
			$mail->AddAddress($zakaznik->vratEmail());
						
			$mail->Priority = 1;
			$mail->IsHTML(true);
			$mail->Subject  = "Obnovení hesla";
			$mail->AltBody  = "Pokud chcete zobrazit kompletně tento e-mail, zvolte možnost Zobrazit / Zapnout HTML";			
			$mail->MsgHTML($telo);			
						
			if (!$mail->Send())
			{
				throw new Chyba("Nepodařilo se odeslat e-mail pro obnovu hesla: ".$mail->ErrorInfo);
			}			
			new Potvrzeni("Na zadaný e-mail vám byly zaslány údaje potřebné pro obnovení hesla.");
		    
		}
		catch(Chyba $e)
		{}
	}
	
	private function kontrolaTokenu($token,$email)
	{		
			$zakaznik = Zakaznik::vratZakaznikaDleEmailu($email);
			$ulozenyToken = $zakaznik->vratObnovaHeslaToken();
			if (!$ulozenyToken)
			{
				Throw new Chyba("Platnost tokenu pro obnovu hesla vypršela.");
			}
				
			$platnostTokenu = DateTime::createFromFormat("Y-m-d H:i:s",$zakaznik->vratObnovaHeslaCas());
			$platnostTokenu->modify('+'.__PLATNOST_TOKENU_OBNOVENI_HESLA__.' hours');
			$cas = new Datetime();
			if ($cas->format("Y-m-d H:i:s") > $platnostTokenu->format("Y-m-d H:i:s"))
			{
				Throw new Chyba("Platnost tokenu pro obnovu hesla vypršela.");
			}
			if (!password_verify($token, $ulozenyToken))
			{
				Throw new Chyba("Neplatný token pro obnovu hesla.");
			}
			return $zakaznik;
	}
	
	
	private function formularZmenyHesla($token,$email)
	{
		try
		{
			$zakaznik = $this->kontrolaTokenu($token,$email);
			Kernel::$sablona->assign("zakaznik",$zakaznik);
			Kernel::$sablona->nastavTelo("obnovaHesla.zmena.tpl");
			Kernel::$sablona->assign("tokenNesifrovany",$token);
		}
		catch(Chyba $e)	{			
		}
	}
	
	private function zmenaHesla($token,$email,$heslo,$heslo2)
	{
		try
		{   
			$zakaznik = $this->kontrolaTokenu($token,$email);		
			try
			{
				$zakaznik->nastavHeslo($heslo,$heslo2);
				$zakaznik->ulozit();
				$zakaznik->pozadavekNaObnovuHesla($zrusit = true);
				new Potvrzeni("Vaše heslo bylo úspešně změněno");	
				FK::presmerovat(__WEB__);		
			}
			catch(Chyba $e)	
			{
				//chyba při změne hesla -> znovu zobrazit formulář pro změnu
				Kernel::$sablona->assign("zakaznik",$zakaznik);
				Kernel::$sablona->nastavTelo("obnovaHesla.zmena.tpl");
				Kernel::$sablona->assign("tokenNesifrovany",$token);
			}
		}	
		catch(Chyba $e)	{} //chyba při kontrole tokenu -> zpět na začátek	
		
		
	}
	
	
}