<?php 
       
class KontrolerRezervace
{	
 function __construct()
 {  
  try 
   { 
	   if (isset($_GET["reset"]))
	   {
	   		unset($_SESSION["objednavka"]);
	   		FK::presmerovat();
	   }	  
	   if (isset($_SESSION["objednavka"]["obj"]))
	   {
	   	//pokračovat v objednávce
	   	$objednavka = Rezervace::ziskatZeSession();	   	
	   } 
	   else
	   {   
	   	$objednavka = new Rezervace();	   	
	   	$objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace')); // zruseni callback fce	   	
	   }

   }
   catch(Chyba $e)
   {
   	 //chyba při načítání objednávky
   	 FK::presmerovat(__WEB__);
   }
    
   try 
   { 	   
   	
   	   //byl odeslám formulář nebo se datum ještě nebylo nastaveno
   	   if (FK::post("zmena") or !$objednavka->vratDatumOd()) 
   	   {
	   	   $this->nastavRozsahRezervace($objednavka,FK::post("rezervaceRozsah"));
	   	  
	   	   $dostupnost = new Dostupnost($objednavka); 
		   //načíst vybrané pokoje nebo skupiny pokojů
	   	   $sp = (isset($_POST["sp"]) and is_array($_POST["sp"])) ? $sp = $_POST["sp"] : array();
	   	   $po = (isset($_POST["po"]) and is_array($_POST["po"])) ? $po = $_POST["po"] : array();
	   	   $dostupnost->nastavVybranePokoje($po);
		   $dostupnost->nastavVybraneSkupinyPokoju($sp);
   	   }
   	   else 
   	   {
   	   	$dostupnost = new Dostupnost($objednavka);
   	   }
	   //zkontrolovat dostupnost a načíst proměnné do šablony	  

   	   $automatickyVyberPokoju = true;
	   $dostupnost->nastavAutomatickyVyberPokoju($automatickyVyberPokoju);
	   $dostupnostStav = $dostupnost->zkontrolujDostupnost();   
	   	   
       //byl odeslám formulář
	   if (FK::post("zmena")) 
	   {
	   	   //nastavit případné změny v parametrech rezervace
	   	   $parametry = $this->nastavParametry($objednavka);
		   if ($parametry)
		   { 
			  if (!$objednavka->vratId())
			   {   	  	
			      $objednavka->ulozitDoSession();
			      //FK::presmerovat("rezervaceZakaznik");
			   }
		    }
	   }

	   Kernel::$sablona->assign('poziceStranky', FK::post("poziceStranky"));
	   Kernel::$sablona->assign('automatickyVyberPokoju',   $automatickyVyberPokoju);
	   Kernel::$sablona->assign('stravaTypy', Strava::vratStravaTypy());
	   Kernel::$sablona->assign('stravaCeny', Strava::vratStravaCeny());
	   Kernel::$sablona->assign('objednavka',  $objednavka);
	   Kernel::$sablona->assign('obsazenoVRezervaci',  $dostupnost->vratObsazenoVRezervaci());
	   Kernel::$sablona->assign('volnoSRezervaci', $dostupnost->vratVolnoSRezervaci());
	   Kernel::$sablona->assign('volnoBezRezervace', $dostupnost->vratVolnoBezRezervace());
	   Kernel::$sablona->assign('kolekceSkupinPokoju', $dostupnost->vratKolekceSkupinPokoju());
	    
	  }
	catch(Chyba $e)
	{
	   	FK::presmerovat();
	}
   } 
   
 private function nastavParametry($objednavka)
  {
      $chyba = false;      
      try{	 
		   	if (is_array(FK::post("strava")))
		   	{
		   		$celkem = 0;
		   		$kolekceStrava = new Kolekce("Strava");		   		
		   		foreach (FK::post("strava") as $stravaId => $pocet)
		   		{
		   			$celkem = $celkem + $pocet;
		   			if ($celkem > $objednavka->vratPocetHostu()){
		   				Throw new Chyba("Počet strávníků nesmí být větší než celkový počet ubytovaných osob.");
		   			}
		   					   			
		   			if ($pocet < 1) {continue;}
		   			$strava = N::strava();
		   			//nastav Id rezervace, pokud editujem
		   			if ($objednavka->vratId()){
		   				$strava->nastavRezervaceId($objednavka->vratId());
		   			}	
		   			$strava->nastavPocet($pocet);
		   			$strava->nastavStravaId($stravaId);
		   			$kolekceStrava->pridej($strava,$stravaId);		   			
		   		}
		   		$objednavka->nastavStrava($kolekceStrava);		   		
		   	}
		 
		  }catch(Chyba $e)  {$chyba = true;}
	   	   	$objednavka->nastavStrava($kolekceStrava);
	   
	    try{ $objednavka->nastavUbytovaciPoplatekOsvobozenoPocet(FK::post("ubytovaciPoplatekPocet"));} catch(Chyba $e)  {$chyba = true;}
	    try{ $objednavka->nastavRekreacniPoplatekOsvobozenoPocet(FK::post("rekreacniPoplatekPocet"));} catch(Chyba $e)  {$chyba = true;}
	    try{ $objednavka->nastavPoznamka(FK::post("poznamka"));} catch(Chyba $e)  {$chyba = true;}
	   $objednavka->nastavCenaCelkem($objednavka->vratCenaCelkemVypoctena());
   	    return !$chyba;
   }


 /**
  * Nastavuje rozsah rezervace 
  * @param Rezervace $objednavka
  * @param string $rozsah (d.m.y - d.m.y)
  * @throws Chyba
  */
 private function nastavRozsahRezervace(Rezervace $objednavka,$rozsah = null)
 {
 	if ($rozsah)
 	{ 	
	 	$rozsah = explode(" ",$rozsah);
	 	if (!isset($rozsah[0]) or !isset($rozsah[2]))
	 	{
	 		Throw new Chyba("Datum je ve špatném formátu");
	 	}
	 	$objednavka->nastavDatum($rozsah[0],$rozsah[2],"d.m.Y");
 	}
 	else
 	{ 		
 		/*if (isset ($_SESSION["posledneVybranyRozsah"]["od"]))
 		{
 		
 		    $rozsahOd = DateTime::createFromFormat("Y-m-d", $_SESSION["posledneVybranyRozsah"]["od"]);
 		    $rozsahDo = DateTime::createFromFormat("Y-m-d", $_SESSION["posledneVybranyRozsah"]["do"]); 		    
 		}
 		else 
 		{*/
 			//nastavit rozsah automaticky
 			$rozsahOd = new Datetime();
 			$dnes = new Datetime();
 			$rozsahDo = $dnes->modify('+1 weeks');
 		//}
 		$objednavka->nastavDatum($rozsahOd->format("d.m.Y"),$rozsahDo->format("d.m.Y"),"d.m.Y");
 	}	
 }
}