<?php 
       
class KontrolerRezervaceZakaznik
{

 function __construct()
 {  
  
 	try { 	
  	   if (isset($_SESSION["objednavka"]["obj"]))
	    {
	        //pokračovat v objednávce
	         $objednavka = Rezervace::ziskatZeSession(); 
	    }     
	    else
	    {    	   	
	    	$objednavka = new Rezervace();
	    	$objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace')); // zruseni callback fce
	    } 
	    if(isset($_POST['prihlasit']))
	    {
	    	$this->prihlasit($objednavka,FK::post("email"),FK::post("heslo"));
	    }
	    if(isset($_POST['registrovat']))
	    {
	    	$this->registrovat($objednavka);
	    }
	    elseif (FK::post("pokracovat"))
	    {
	    	$this->pokracovat($objednavka);
	    }
	    else 
	    {
	    	$zakaznik = PrihlaseniZakaznik::vratZakaznika();
	    	$vyber  =  FK::get("vyber");
	    	
	    	/**
	    	 * naplnit kontaktní údaje, pokud je zákazník přihlášeny
	    	 * tato akce se provádí pouze při prvním příchodu
	    	 */
	    	
	    	if (!isset($_SESSION["objednavka"]["KontaktNacten"])  and $zakaznik)
	    	{	    		
	    		$this->klonujKontaktOdZakaznika($objednavka,$zakaznik);
	    		$_SESSION["objednavka"]["kontakt"] = true;
	    		$_SESSION["objednavka"]["KontaktNacten"] = true;
	    		$objednavka->ulozitDoSession();
	    	}
	    	
	    	if($zakaznik)
	    	{
	    		$this->zobrazJednorazove($objednavka);
	    	}	    	
	    	elseif ($vyber =="prihlaseni")
	    	{
	    		$this->zobrazPrihlaseni();
	    	}
	    	elseif( $vyber =="registrace")
	    	{
	    		$this->zobrazRegistraci();
	    	}
	    	else
	    	{
	    	  $this->zobrazJednorazove($objednavka);
	    	}
	    	
	    	
	    }
  }
  catch(Chyba $e){
  	FK::presmerovat(__WEB__);
  }
  
  }    
    
    
  private function zobrazPrihlaseni()
  {
  	Kernel::$sablona->assign('sablonaObsah',"rezervaceZakaznik.prihlaseni.tpl");
  	Kernel::$sablona->assign('vyber', "prihlaseni");
  }
  
  private function zobrazRegistraci($kontakt = null)
  {
  	$kontakt = (!$kontakt) ? N::Kontakt() : $kontakt; 
  	
  	Kernel::$sablona->assign('kontakt', $kontakt);
  	Kernel::$sablona->assign('sablonaObsah',"rezervaceZakaznik.registrace.tpl");
  	Kernel::$sablona->assign('staty', Kontakt::vratStaty());
  	Kernel::$sablona->assign('vyber', "registrace");
  }
  
  private function zobrazJednorazove(Rezervace $objednavka)
  {  
  	Kernel::$sablona->assign('nezobrazovatPoleProHeslo', true);
  	Kernel::$sablona->assign('sablonaObsah',"rezervaceZakaznik.jednorazove.tpl");
	Kernel::$sablona->assign('staty', Kontakt::vratStaty());
	Kernel::$sablona->assign('kontakt',  $objednavka->vratKontakt());
	Kernel::$sablona->assign('vyber', "jednorazove");
  }
  
  /**
   * přidá kontak od zákazníka do objednávky
   * @param Rezervace $objednavka
   * @param Zakaznik $zakaznik
   */
  private function klonujKontaktOdZakaznika(Rezervace $objednavka,Zakaznik $zakaznik)
  {
  	$objednavka->nastavKontakt(clone $zakaznik->vratKontakt());
  	$objednavka->vratKontakt()->nastavId(null);
  	$objednavka->nastavZakaznikId($zakaznik->vratId());
  	$_SESSION["objednavka"]["kontakt"] = true;
  }
  
  
   /**
    * přihlásí zákazníka a nastaví kontakt objednávky
    * @param Rezervace $objednavka
    * @param unknown $email
    * @param unknown $heslo
    */
    private function prihlasit(Rezervace $objednavka,$email,$heslo) 
    {
		try
		{	    		
			PrihlaseniZakaznik::kontrolaPrihlasovacichUdaju($email,$heslo);   
			$zakaznik = PrihlaseniZakaznik::vratZakaznika();            
			$this->klonujKontaktOdZakaznika($objednavka,$zakaznik);
			$objednavka->ulozitDoSession();			
			FK::presmerovat(); 
       }
       catch(Chyba $e)
       {  
            kernel::$sablona->assign('email', $email); 
            $this->zobrazPrihlaseni();
       }
     }
  	     
    /**
     * nastavuje kontaktní informace k rezervaci
     * při vytváření rezervace nastavuje session podle úpěchu metody
     * @param Rezervace $objednavka
     * @throws Chyba
     */
    private function nastavKontakt(Rezervace $objednavka)
    {  
    	$chyba = false;
    	$kontakt = $objednavka->vratKontakt();
    	   	
    	
    	try{ $kontakt->nastavEmail(FK::post("email")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavJmeno(FK::post("jmeno")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavPrijmeni(FK::post("prijmeni")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavMesto(FK::post("mesto")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavCisloPopisne(FK::post("cisloPopisne")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavSmerovaciCislo(FK::post("smerovaciCislo")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavUlice(FK::post("ulice")); } catch(Chyba $e)  {$chyba = true;}    	
    	try{ $kontakt->nastavStatId(FK::post("stat")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavIco(FK::post("ico")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavDic(FK::post("dic")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavOrganizace(FK::post("organizace")); } catch(Chyba $e)  {$chyba = true;}    	
    	try{    		
    		Validace::telefon(FK::post("telefon"),array("povinny" => true));
    		$kontakt->nastavTelefon(FK::post("telefon")); 
    	   } 
    	   catch(Chyba $e)  {$chyba = true;}    	
    	
    	
    	if (!$objednavka->vratId()){
    		$_SESSION["objednavka"]["kontakt"] = !$chyba;
    	}    	
    	if ($chyba) 
    	{    		
    		throw new Chyba("Nebyly správně vyplněny všechny povinné údaje");
    	}
    }
    
    /**
     * ukládá do session změny v kontaktu
     * @param Rezervace $objednavka
     */    
    private function pokracovat(Rezervace $objednavka)
    {
    	try
    	{  
    		$this->nastavKontakt($objednavka);
    		$objednavka->ulozitDoSession();    		
    		FK::Presmerovat("rezervaceShrnuti");
    	}
    	catch(Chyba $e)  
    	{    		
    		$objednavka->ulozitDoSession();
    		FK::Presmerovat();
    	}
    }
        
	/**
	 * Zaregistruje zákazníka, přihlásí, a uloží kontakt do session
	 * @param Rezervace $objednavka
	 * @throws Chyba
	 */
    
    private function registrovat(Rezervace $objednavka)
    {
    	$chyba = false;
    	try {    
    		
    		$zakaznik = N::Zakaznik() ;
    		$kontakt = $zakaznik->vratKontakt();
    		
    		try{ $zakaznik->nastavHeslo(FK::post("heslo"), FK::post("heslo2")); } catch(Chyba $e)  {$chyba = true;}    		
    		try
    		{
    			$zakaznik->nastavEmail(FK::post("email"));
    			$kontakt->nastavEmail(FK::post("email"));
    			 
    		} catch(Chyba $e)  {$chyba = true;}
    
    		try{ $kontakt->nastavJmeno(FK::post("jmeno")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavPrijmeni(FK::post("prijmeni")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavMesto(FK::post("mesto")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavCisloPopisne(FK::post("cisloPopisne")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavSmerovaciCislo(FK::post("smerovaciCislo")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavUlice(FK::post("ulice")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavTelefon(FK::post("telefon")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavStatId(FK::post("stat")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavIco(FK::post("ico")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavDic(FK::post("dic")); } catch(Chyba $e)  {$chyba = true;}
    		try{ $kontakt->nastavOrganizace(FK::post("organizace")); } catch(Chyba $e)  {$chyba = true;}
    
    
    		if ($chyba)
    		{
    			throw new Chyba('Údaje nebyly uloženy');   //nějaká chyba v ověřování vstupu
    		}
    		 
    		$zakaznik->ulozit();    
    		new Potvrzeni('Údaje byly uloženy.');
    		//přihlásit zákazníka
    		PrihlaseniZakaznik::kontrolaPrihlasovacichUdaju($zakaznik->vratEmail(),FK::post("heslo"));
    		//nastavit kontakt u rezervace
    	    $this->klonujKontaktOdZakaznika($objednavka,$zakaznik);
    		$objednavka->ulozitDoSession();
    		FK::presmerovat();
    	}
    	catch(Chyba $e)
    	{    		
    		$this->zobrazRegistraci($kontakt);
    	}
    }
     

}