<?php 

abstract class BO2 extends Accessor
{
    
  public function __construct($id=null) {
   	  	
  if ($id === NULL)
  {
  	//vytvořit prázdný	
  }
  elseif (!$id)
  {
  	new Chyba ("Chybný identifikátor [".get_class($this)."]") ;
  	FK::presmerovat();
  }
  else
  {   	   
   	   	$this->id = $id;   	 
       	$this->vrat();
  }   
}
   
   
   protected function nastavId($id)
   {    	
   	$this->id = $id;
   	if(!static::$kolekce){
   		static::$kolekce	= new Kolekce(get_class($this));
   	}
   	static::$kolekce->pridej($this,$id);
   }
   
   	
  protected function vrat()
	{
	  $parametry = array("id"=>$this->id);
      $dotaz = "SELECT 	".implode(",",array_values(static::$mapovaniDB))." FROM " . static::$tabulkaDB . " WHERE ". static::$mapovaniDB["id"]. " = :id LIMIT 1";      
      $vysledek = DB::dotazJeden($dotaz,$parametry);
	  if(!$vysledek) {
	  	Throw new Chyba ("Položka [".get_class($this)."] s tímto id [".$this->id."] neexistuje.");
	  }	  
	  $this->nactiAtributy($vysledek);   
	 } 
      
   protected function nactiAtributy($radek)
	{  
	  foreach (static::$mapovaniDB as $promenna => $sloupecDB) 
      {
         if ($promenna == "id")
         {             
            $id = ($radek[$sloupecDB])? $radek[$sloupecDB] : null;
         	$this->nastavId($id);
         }        
         elseif($radek[$sloupecDB] === null)
         {         	
         	eval('$this->'. $promenna .' = null;');
         }
         else
         {
         	$this->$promenna = $radek[$sloupecDB];         
         }  
      }
   }
  
   
   public function ulozit()
   {       	
   	if (!$this->id)
	{	         
        $vlozit = null;
        $hodnoty = null;
        $dotaz = "INSERT INTO " . static::$tabulkaDB . " ";
        foreach (static::$mapovaniDB as $promenna => $sloupecDB) 
        {
   			$vlozit.=  $sloupecDB. ",";
          	$hodnoty.= ":".$promenna. ",";
          	$parametry[$promenna] = $this->$promenna;
   		}
        
        $vlozit   = rtrim($vlozit, ","); 
        $hodnoty  = rtrim($hodnoty, ",");
        $dotaz.= "(".  $vlozit .") VALUES (".  $hodnoty .")";        
        $vysledek = DB::dotaz($dotaz,$parametry);
        if (!$vysledek)	 throw new Chyba('Údaje nebyly uloženy');
        $this->nastavId(DB::posledniId()); 
	}
	else
	{ 		
	    $parametry = array("id"=>$this->id);
	    $dotaz = "UPDATE " . static::$tabulkaDB . " SET ";
	    foreach (static::$mapovaniDB as $promenna => $sloupecDB) 
	    {	   		
	       $dotaz.=  $sloupecDB. "=:".$promenna.",";
	       $parametry[$promenna] = $this->$promenna;	          
	   	}
	        
	    $dotaz = rtrim($dotaz, ",");
	    $dotaz.= " WHERE ".static::$mapovaniDB['id']."=:id LIMIT 1";
	    $vysledek = DB::dotaz($dotaz,$parametry);
	    if (!$vysledek)	 throw new Chyba('Údaje nebyly uloženy');
		}
   }
   
   public function smazat()
   {
   	 $this->kontrolaID();
   	 $dotaz = "DELETE FROM " . static::$tabulkaDB . " WHERE ".static::$mapovaniDB['id']."=:id LIMIT 1";
   	 $parametry = array("id"=>$this->id);
   	 $vysledek = DB::dotaz($dotaz,$parametry);
   }
    
   
   
   /**
    * Metoda volana z podtridy
    * Zkontroluje jestli je nastaveno jeji ID,jestlize ne, vyhodi vyjimku
    * @throws Chyba
    */     
 
   public function kontrolaID()
   {
   	 if (!$this->id) {  
   	 	throw new Chyba ("Tuto akci nelze provést bez nastaveného ID.") ;   	 	
   	 }   	 
   }
     
   /**
    * Kontroluje, jestli mají atributy nulovou hodnotu, pokud ano, vyhazuje výjimku 
    * @param string|array $atributy
    * @throws Chyba
    */
   
   protected function kontrolaAtributu($atributy)
   {
   	 if (is_array($atributy))
     {
       foreach ($atributy as $atribut)
        {
         	if ($this->$atribut===null)      	
         	throw new Chyba ("Povinný atribut '$atribut' nebyl nastaven.") ;
        }
     }
     else
     {
       	if ($this->$atributy===null)      	
        throw new Chyba ("Povinný atribut '$atributy' nebyl nastaven.") ;
     }     
   }
    
  
   protected static function nelzeNastavit()
   {
   	throw new Chyba ("Tento atribut nelze nastavit Přímo");
   }
   
   
   /**	Metoda kterou vyuzivaji, podobjekty BO
    * 	Zjišťuje, jestli instance objektu s ID v $poleID jiz nebyla vytvorena,
    * 	jestliže ano, přidá je rovnou do $aktualniKolekce a odstraní z $poleID.
    * 		
    * 	$kolekce - obj Kolekce
    *   $poleId array -> primarni klice pozadovanych objektu
    *   vrací  obsahujující id zatím nevytvořených instancí 	
    */
   //$dotaz,$parametry=array()
   final public static function kolekce(Kolekce $aktualniKolekce,$poleID)
   {     
   	
   	if (!is_array($poleID))
   	{
   		return false;
   	}
   	
   	if (count(array_unique($poleID)) != count($poleID))
   	{
   		throw new Vyjimka ("Pole musí obsahovat unikátní ID.");
   	}   	
   	   
   	$poradi = $poleID;
   	if 	(static::$kolekce)
   	{
   	foreach ($poleID as $klic => $id)
   	 {   		   			
   			//instance existuje v kolekci tridy   
   			if (static::$kolekce->existuje($id))
   			{ 
   				$aktualniKolekce->pridej(static::$kolekce->vrat($id));
   				//nevytvaret dale
   				unset ($poleID[$klic]);
   			}   		
   	  }
   	 }   	  		
   
   	 if ($poleID != array())
   	  {
   	  	$dotaz = null;  
   		if (!$dotaz)
        { 
            $dotaz = "SELECT ".implode(",",array_values(static::$mapovaniDB))." FROM " .static::$tabulkaDB . " WHERE " .static::$mapovaniDB["id"] ." IN ('".implode("','",array_values($poleID))."')";   
        }
        else
        {
            $dotaz = str_replace(":poleID","'".implode("','",array_values($poleID))."'", $dotaz); 
        }
                        			
   		    $vysledek = DB::dotazVsechny($dotaz,$parametry=array());
   			foreach ($vysledek as $radek)
   			{   				
          		$obj = new static();
   				$obj->nactiAtributy($radek);
   				$aktualniKolekce->pridej($obj);
   			} 
   	   }
   	    $aktualniKolekce->seradit($poradi);
   }
   
 
   
  public static function kolekceVsech($kolekce)
	{
		$dotaz = "SELECT " .static::$mapovaniDB["id"] . " FROM " .static::$tabulkaDB;  		
		self::Kolekce($kolekce,DB::dotazJedenSloupec($dotaz,array()),null,array());
	}
  
  public function kolekceSouvisejicich(Kolekce $kolekce)
  {   
     if ($this->id)
     {     	
      $trida = $kolekce->vratPovoleneObjektyTridy();
      $dotaz = "SELECT " .$trida::$mapovaniDB["id"] . " FROM " .$trida::$tabulkaDB. " WHERE ".static::$mapovaniDB["id"]." = :id";	
      $parametry = array("id" => $this->id);
      $poleID = DB::dotazJedenSloupec($dotaz,$parametry);       
	  $trida::Kolekce($kolekce,$poleID);
     }
  } 
   
   
  /**
   * vrací asociativní pole atributů potomka
   * jen public a protected
   * @return array:
   */
  
   public function zobraz()
   {
   	$atributy = get_object_vars($this);
   	foreach ($atributy as $atribut=> $hodnota)
   	{
   		if  (gettype($hodnota) == "object")
   		{
   			unset ($atributy[$atribut]);
   		}
   	}
   	return $atributy;
   }
   
   public static function vratMapovaniDB($prom = null)
   {   
   	if ($prom){
   		return ((isset(static::$mapovaniDB[$prom]))) ? static::$mapovaniDB[$prom] : null;
   	}   	
   	return (isset(static::$mapovaniDB)) ? static::$mapovaniDB : array();
   }
   public static function vratTabulkaDB()
   {
   	return (isset(static::$tabulkaDB)) ? static::$tabulkaDB : null;
   }
    
   
   
   
} 
