<?php
class Kernel {
		
	public static $sablona = null;	
	private static $modul = null;
	private static $jazyk = null;
	private static $nastaveni = null;
	
	
	
	public function __construct() {
		// zapnutí výstupního bufferu
		ob_start ();
		
		//připojit k databázi
		DB::pripoj(__DB_HOST__, __DB_USER__, __DB_PASS__, __DB_NAME__, __DB_PORT__);	
				
		//spustit session
		if (isset($_SESSION))
		{
			echo "Automatické spoštění session musí být vypnuto.";
			exit();
		}
		session_name(__SESSION_NAME__);
		session_start ();
					
		//parsování url	
		$url = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);
		$url = preg_replace("#^/".__BASE_URL__."#", "", $url,1,$pocet);
		$url = explode("/", $url, 2);
		
		//za názvem modulu může být jen querry string
		if (!empty($url[1]))
		{
			self::$modul = "404";
		}
		//nebyl vybrán modul
		elseif (empty($url[0]))
		{	
			self::$modul = __START_PAGE__;
		}	
		//modul může obsahovat jen písmena alfanumerické znaky
		elseif (preg_match('/[^a-z0-9]/i', $url[0]))
		{
			self::$modul = "404";
		}
		else 
		{
			self::$modul = $url[0];
		}
		
		
		//kontrola přihlášení, pokud je u modulu vyžadována
	    Prihlaseni::kontrolaRelacePrihlaseni(self::$modul);
		
				
		//zapnutí autoloadingu pro modul
		self::$modul = autoloader::pridejModul(self::$modul);
		
		//inicializace templatovacího systému
		self::$sablona = new Sablona();
		self::$sablona->assign("csrfToken",Prihlaseni::vratCsrfToken());
		
		//načtení nastavení z databáze
		self::$nastaveni = new Kolekce("Nastaveni");
		Nastaveni::kolekceNastaveni(self::$nastaveni );
		self::$sablona->assign('kolekceNastaveni', self::$nastaveni);		

		//spuštění kontroleru modulu
		$kontolerTrida = "Kontroler".ucfirst(self::$modul);
		new $kontolerTrida;
	
		self::$sablona->vykreslit();		
	}
	
	public static function vratModul()
	{
		return self::$modul;
	}
	public static function vratNastaveni()
	{
		
		return self::$nastaveni;
	}
}
