<?php 

class Sablona extends Accessor
{

	protected  $smarty = null;
	
	//názvy šablon př: hlavicka.tpl
	protected   $telo = null;
	protected   $hlavicka = null;
	protected   $paticka =null;
	
	protected   $cacheTelo = null;
	protected   $cacheHlavicka = null;
	protected   $cachePaticka =null;
	
	/**
	 * cesty k css a js souborum
	 * vytváří se automaticky prohledáním složky modulu
	 * false -> neprohledávat modul
	 */	
	protected   $cssModul = null;		
	protected   $jsModul = null;
			
	protected $titulekStranky = null;
	
	
	public function  __construct()
	{
		$modul = Kernel::vratModul();
		$this->smarty = new  Smarty;
		
		if (defined ("__CSRF_OCHRANA__") and __CSRF_OCHRANA__){
		$this->smarty->registerFilter("pre", array($this,"csrfOchrana"));	
		}		
	
		//zamění všechny speciální znaky ve výstupních proměnný za html entity 
		$this->smarty->escape_html = true ;
		//složky se šablonamy - hlavní + složka modulu
		$this->smarty->setTemplateDir(array(__SLOZKA_MODULU__.$modul.__DSEP__.__SLOZKA_SABLON_MODULU__,__SLOZKA_SABLON__));  
		//nastavení k cesty ke zkompilovaným šablonám
		$this->smarty->setCompileDir(__SLOZKA_TEMP__.__DSEP__."_smartyKompilace");
		//nastavení složky s cache
		$this->smarty->setCacheDir(__SLOZKA_TEMP__.__DSEP__."_smartyCache");
		
		
		//deafultni nastaveni cest k sablonam
		$this->telo = $modul.".tpl";
		$this->hlavicka = "hlavicka.tpl";
	    $this->paticka = "paticka.tpl";
	    
	    //cachovani jednotlivych sablon
	    $this->cacheTelo = false;
	    $this->cacheHlavicka = false;
	    $this->cachePaticka = false;	 
	    	    	    	    
		//bez toho nefunguje kontrola cachovani
		$this->smarty->setCaching(true);
	}
	
	//odeslat výstup
	public function vykreslit()
	{
		
		echo $this->fetch();
	}
	
	
	public  function fetch()
	{
	 	
		
	$modul = Kernel::vratModul();
	$vystup = null; 
	//hlavicka
	//css	
	if ($this->hlavicka != false)
	  {	
	  	//prohledání složky modulu a uložení cesty k css a js do pole
	  	$this->cssModul = ($this->cssModul !== false) ?  self::nactiMedia(".".__DSEP__."_modul".__DSEP__.$modul.__DSEP__."\_css".__DSEP__."*css") : array();
	    $this->jsModul = ($this->jsModul !== false) ?  self::nactiMedia(".".__DSEP__."_modul".__DSEP__.$modul.__DSEP__."\_js".__DSEP__."*js") : array();

	    $this->smarty->assign('css', $this->cssModul);
	  	$this->smarty->assign('javaScript', $this->jsModul);   
	  	
	  	$this->smarty->assign("hlavickaTitulekStranky", ($this->titulekStranky) ? $this->titulekStranky : $modul);
	    
	    if ($this->cacheHlavicka !== false)
	    {
	    		$this->smarty->setCaching(Smarty::CACHING_LIFETIME_SAVED);
	    		$this->smarty->setCacheLifetime($this->cacheHlavicka);
	    }
	    else 
	    {
	    		$this->smarty->setCaching(false);
	    }	  
	  	    
	    //pro zobrazení nových rezervací
	    $dnes = new Datetime();
	    $rozsahOd = $dnes->modify('-2 months')->format('d.m.Y');	    
	    $rezervaceFiltr = new RezervaceFiltr();
	    $rezervaceFiltr->nastavDatumOd($rozsahOd);
	    $rezervaceFiltr->nastavStavId(1);	    
	    $rezervaceFiltr->nastavpriNenalezeni("return");
	    $this->smarty->assign('noveRezervace', $rezervaceFiltr->vratkolekce());
	    
	    //Existuje nějaká rozpracovaná rezervace (status pro menu) 	
	    $this->smarty->assign('menuRozpracovanaRezervace', isset($_SESSION["objednavka"])? true : false);
	 	    
	    //nacti prihlaseneho uzivatele
	    $this->smarty->assign('prihlasenyUzivatel', Prihlaseni::vratUzivatel());
	    
	    $vystup.= $this->smarty->fetch($this->hlavicka);
	  }
	
      //telo
	  if ($this->telo)
	  {
	
	  	 	  
	   //přiřadit pole zpráv zachycených výjimek
	   $this->smarty->assign('hlaseni',Vyjimka::vratPole(), true);
	   
	   if ($this->cacheTelo !== false)
	   {
		   	$this->smarty->setCaching(Smarty::CACHING_LIFETIME_SAVED);
		   	$this->smarty->setCacheLifetime($this->cacheTelo);
	   }
	   else
	   {
	   		$this->smarty->setCaching(0);
	   }
	   	   
	   
	   $vystup.=$this->smarty->fetch($this->telo);	  
	  } 

	  
	  //paticka	  
	  if ($this->paticka != false)
	  { 
		  if ($this->cachePaticka != false)
		  {
		  	 $this->smarty->setCaching(Smarty::CACHING_LIFETIME_SAVED);	  
		  	 $this->smarty->setCacheLifetime($this->cachePaticka);		  	 
		  }
		  else
		  {
		  	$this->smarty->setCaching(0);
		  }
	 	  $vystup.= $this->smarty->fetch($this->paticka);
	  }
		
	  return $vystup;
	}	
		
			
	protected  function nactiMedia($glob){		
		
		$souboryVystup = array();
		$soubory = glob($glob);	
		if (is_array($soubory))
		{
			foreach ($soubory as $soubor)
			{			
				$soubor	= ltrim ($soubor,'.\/'); 
				$soubor = str_replace('\\', '/', $soubor);
				$soubor = __WEB__.$soubor;
				$souboryVystup[] = $soubor;
			}	
		}	
		return $souboryVystup;	
	}
	
	public  function assign($nazev,$prom){
		$this->smarty->assign($nazev,$prom);	
	}

	
	/**
	 * Přidává do všek formulářů typu post s relativní cestou skyrytý input s tokenem proti csrf útokům
	 * @param unknown $tpl_output - html výstup
	 * @param Smarty $smarty
	 * @return unknown
	 */
	public function csrfOchrana($tpl_output, $smarty)
	{	
		$hidden = '<input type="hidden" name="csrfToken" value="{$csrfToken}" />';
		$return = preg_replace('~<form\\s+(?![^>]*\\baction=[\'"]?(?:https?:|//))[^>]*\\bmethod=[\'"]?post[^>]*>~i', "\\0\n$hidden", $tpl_output);
		
		return $return;
	}
	
	
	
	
	
	
	
}