<?php
class  Uzivatel extends BO2
{
 
 private $heslo = null; //heslo lze používat jen v rámci třídy
 
 protected $id = null;
 protected $email = null;
 protected $jmeno = null;
 protected $prijmeni = null;
 
  protected static $kolekce;
  
  protected static $tabulkaDB = "uzivatel";
  protected static $mapovaniDB = array ( 
   "id" => "id_uzivatel",
   "email" => "email",
   "jmeno" => "jmeno",
   "prijmeni" => "prijmeni",
   );

  
 function __construct($id=null)
 {
 	parent::__construct($id);
 }
 
   
 /**
  * zajištuje že nebudou dva uživatelé se stejnými e-maily
  * @param string $email
  * @throws Chyba
  */
 public function nastavEmail($email)
 {
		
 	Validace::email($email);
 	$dotazId =null;
 	
	  if ($this->id)
	  {
	  	$dotazId = " and id_uzivatel <> :id ";
	  	$parametry["id"] = $this->id;
	  }
	 
	  	$parametry["email"] = $email;  
	    $dotaz = "SELECT id_uzivatel FROM uzivatel WHERE email = :email $dotazId LIMIT 1";	
	  
	  if(DB::dotazPocet($dotaz,$parametry) != 0)
	  {
	   throw new Chyba('Registrace se stejným e-mailem již existuje.');
	  }
	  $this->email = $email;
 }

 public function nastavHeslo($heslo,$heslo2)
 { 	
 	  Validace::delka($heslo, 6, 255, "Heslo"); 	
	  if ($heslo != $heslo2)
	  {
	   throw new Chyba('Hesla se neshodují.');
	  }
	  else
	  {	  	
	  	$this->heslo = password_hash($heslo, PASSWORD_DEFAULT);	  	
	  }
 }
 
 
 public function nastavJmeno($jmeno)
 {
	  Validace::delka($jmeno,1,20,'Jméno');
	  $this->jmeno = $jmeno;   
 }


 /**
  * přetěžuje rodičovskou metodu, heslo ukladá jen při vytvoření uživatele nebo změně
  * dotazy se vytvářejí zde také kvůli absenci hesla při mapování do db 
  */
 
 function ulozit() {
   
  $parametry = array("jmeno" => $this->jmeno, "prijmeni" => $this->prijmeni, "email" => $this->email);
  if (!$this->id)
  {
  	if (!$this->heslo)
  	{
  		throw new Chyba("Nebylo nastaveno heslo");
  	}
  	$parametry["heslo"] = $this->heslo;
  	$dotaz = "INSERT INTO uzivatel (jmeno,prijmeni, email,heslo) VALUES(:jmeno,:prijmeni,:email,:heslo)";
  	DB::dotaz($dotaz,$parametry);
  }
  else
  {
	if ($this->heslo)
	{
		$dozaHeslo = ",heslo=:heslo ";
		$parametry["heslo"] = $this->heslo;
	}  	
  	$parametry["id"] = $this->id;
   	$dotaz = "UPDATE uzivatel SET jmeno=:jmeno, prijmeni=:prijmeni, email=:email $dozaHeslo WHERE id_uzivatel=:id";
   	DB::dotaz($dotaz,$parametry);
  }
 }
}
