<?php
class  Validace
{
	public static function delka($vstup,$min,$max,$nazev)
	{
		if (strlen($vstup)<$min)
		{
			throw new Chyba($nazev.' musí mít alespoň ' .$min. ' znaků.');
		}
		if (strlen($vstup)>$max)
		{
			throw new Chyba($nazev.' nesmí být delší než ' .$max. ' znaků.');
		}
	}

	/* Kontrola jesli je vstup v rozmezi povolenych hodnot
	 * @vstup array nebo string 
	 * @povolene hodnoty array
	 */		
	public static function vycet($vstup, $povoleneHodnoty,$nazev)
	{		
		$vstupArr = array();
		
		if (!is_array($vstup))
		{			
			$vstupArr[0] = $vstup;
		}
	   else 
	    {
	    	$vstupArr = $vstup;
	    }
		foreach ($vstupArr as $hodnota )
		{
			if (!in_array ($hodnota,$povoleneHodnoty))
			{
			throw new Chyba($nazev. " má nepovolenou hodnotu.");
			}	
		}
			
		
		
	}
	
	public static function telefon($telefon,$nastaveni = array("povinny" => true))
	{
		if (!$telefon and isset($nastaveni['povinny']) and $nastaveni['povinny'])
		{
			throw new Chyba('Telefon musí být vyplněn');
		}		
		if($telefon and !preg_match('/^(\+420)? ?[0-9]{3} ?[0-9]{3} ?[0-9]{3}$/',$telefon))
		{
			throw new Chyba('Telefon je ve špatném formátu');
		}
	}
	

	public static function email($email)
	{
		if (!filter_var($email, FILTER_VALIDATE_EMAIL))
		{
			throw new Chyba('Email je ve špatném formátu.');
		}
	}
	
	public static function url($text,$nazev)
	{
		if(preg_match('/[^a-z_\-0-9]/', $text))
		{
			throw new Chyba($nazev.' může obsahovat jen malá písmena a-z, čísla, pomlčku a podtržítko');
		}
	}
	
	
	public static function numeric($vstup,$nazev,$nastaveni = array())
	{
		
		if (!isset($vstup) and isset($nastaveni['povinny']) and $nastaveni['povinny'])
		{
			throw new Chyba($nazev.' musí být číslo.');
		}		
		if (!is_numeric($vstup))
		{
			throw new Chyba($nazev.' musí být číslo.');
		}
		if (isset($nastaveni['max']) and ($vstup > $nastaveni['max']))
		{
			throw new Chyba($nazev.' může být maximálně ' .$nastaveni['max']. '.');
		}
		if (isset($nastaveni['min']) and ($vstup < $nastaveni['min']))
		{
			throw new Chyba($nazev.' může být minimálně ' .$nastaveni['min']. '.');
		}
		
		
	}

	public static function integer($vstup,$nazev,$nastaveni = array())
	 { 
	 	self::numeric($vstup,$nazev,$nastaveni);             
        if (filter_var($vstup, FILTER_VALIDATE_INT)!==0 and filter_var($vstup, FILTER_VALIDATE_INT)===false)
        {
        	 throw new Chyba($nazev.' musí být celé číslo.');
        }
         
	}


	public  static  function datum($datum, $format = 'Y-m-d')
	{
		
		$d = DateTime::createFromFormat($format,$datum);	

		if (($d && $d->format($format) == $datum) !== true)
		{
			throw new Chyba("datum je ve špatném formátu");
		}
		return true;
	}


}