<?php 
       
class KontrolerPrehledrezervaci
{

 function __construct()
 { 
 	if(isset($_REQUEST['zrusitFiltr']))
 	{
 		$this->zrusitFiltr();
 	}
 	if (FK::post("generovatCSV"))
 	{
 		$this->generovatCSV();
 	} 	
 	else
 	{
 		$this->prehledRezervaci();
 	}
 	
 }	
 	
 	
    /**
     * vytvoří instanci RezervaceFiltr z $_POST a $_SESSION požadavků
     * @return RezervaceFiltr
     */
 	private function sestavFiltr()
 	{ 		
 		$rezervaceFiltr = new RezervaceFiltr();
 		if (FK::get('strana'))
 		{
 			$rezervaceFiltr->nastavStrana(FK::get('strana'));
 		}
 			
 		$atributy = array("rezervaceId","datumOd","datumDo","zakaznik","stavId","triditPodle","triditSmer","cisloFaktury");
 		
 		foreach ($atributy as $atribut)
 		{
 			if (isset($_POST['rezervaceFiltr'][$atribut]))
 			{
 				$$atribut = $_POST['rezervaceFiltr'][$atribut];
 			}
 			elseif (isset($_SESSION['rezervaceFiltr'][$atribut]))
 			{
 				$$atribut = $_SESSION['rezervaceFiltr'][$atribut];
 			}
 			else { $$atribut = null;}
 		} 		
 		 		 
 		$rezervaceFiltr->nastavRezervaceId($rezervaceId);
 		$rezervaceFiltr->nastavDatumOd($datumOd);
 		$rezervaceFiltr->nastavDatumDo($datumDo);
 		$rezervaceFiltr->nastavZakaznik($zakaznik);
 		$rezervaceFiltr->nastavStavId($stavId);
 		$rezervaceFiltr->nastavCisloFaktury($cisloFaktury);
 	
 		$rezervaceFiltr->nastavTriditPodle($triditPodle ? $triditPodle : "id");
 		$rezervaceFiltr->nastavTriditSmer($triditSmer ? $triditSmer : "desc" );
 	    return $rezervaceFiltr; 	
 	}
 	
 	private function prehledRezervaci()
 	{ 	
 	
 	try {
 		
 		$rezervaceFiltr = $this->sestavFiltr();	
 		$rezervaceFiltr->nastavPocetNaStrance(20);
 		 		 	
 	    Kernel::$sablona->assign('kolekceRezervaci', $rezervaceFiltr->vratKolekce()); 
 	    Kernel::$sablona->assign('rezervaceFiltr', $rezervaceFiltr); 
 	    Kernel::$sablona->assign('stavy',StavRezervace::vratStavy());
 	    $strankovani = new Strankovani(	$rezervaceFiltr->vratPocetPolozek(), 	$rezervaceFiltr->vratStrana(), 	$rezervaceFiltr->vratPocetNaStrance());
 	    Kernel::$sablona->assign('strankovani', $strankovani);
 	    
 	    $_SESSION['rezervaceFiltr'] = $rezervaceFiltr->vratAtributy();
 	} 	 	
   catch(Chyba $e)
    {
    	FK::presmerovat(__WEB__);
    } 
 }
 
  
 private function zrusitFiltr()
 {
 	unset($_SESSION['rezervaceFiltr']);
 	FK::presmerovat();
 }
 
 /**
  * vytvoří CSV dokument a nabídne ke stažení
  */
 private function generovatCSV()
 {	
 		try{ 			 
 			$rezervaceFiltr = $this->sestavFiltr();	 
 			$rezervaceFiltr->nastavPriNenalezeni("return");
 			if (!$rezervaceFiltr->vratPocetPolozek())
 			{
 				throw new chyba("Nebyly nalezeny žádné odpovídající rezervace. Soubor nebude vygenerován.");
 			}
 			
 			$zahlavi = array("id","datum_od","datu_do","stav","pocet_noci","cena_ubytovani","poplatky","cena_stravovani","cena_sluzby","cena_celkem","sleva","cislo_faktury","dobropisovano","pocet_hostu","pokoje",
 			"Dospeli_plna_penze","Dospeli_polopenze","Deti_plna_penze","deti_polopenze","jmeno","prijmeni","organizace" 					
 			);  
 	
 			$data = array();
 			$data[] = $zahlavi; 			 
 		
 			 
 			foreach  ($rezervaceFiltr as $rezervace)
 			{
 				$pokoje = null;
 				foreach ($rezervace->vratPokojRezervace() as $pokojRezervace)
 				{
 					$pokoje .= $pokojRezervace->vratPokoj()->vratNazev() ." ";
 				};
 				
 				$kontakt = $rezervace->vratkontakt(); 				
 				
 				$data[] = array (
 						$rezervace->vratId(),
 						$rezervace->vratDatumOd(), 						
 						$rezervace->vratDatumDo(),
 						$rezervace->vratSoucasnyStav()->vratStav(),
 						$rezervace->vratPocetNoci(),
 						$rezervace->vratCenaUbytovaniBezPoplatku(),
 						$rezervace->vratPolatkyCelkovaCena(),
 						$rezervace->vratCenaStravovaniCelkem(),
 						$rezervace->vratCenaSluzbyCelkem(), 						
 						$rezervace->vratCenaCelkem(),
 						$rezervace->vratSlevaJednotky(), 						
 						$rezervace->vratCisloFaktury(), 
 						$rezervace->vratDobropisCena(),
 						$rezervace->vratPocetHostu(),
 						$pokoje, 						
 						$rezervace->vratStravaId(1)->vratPocet(),
 						$rezervace->vratStravaId(2)->vratPocet(),
 						$rezervace->vratStravaId(3)->vratPocet(),
 						$rezervace->vratStravaId(4)->vratPocet(),
 						$kontakt->vratJmeno(),
 						$kontakt->vratPrijmeni(),
 						$kontakt->vratOrganizace(), 						
 				 );
 				 
 			}
 			ob_end_clean();
 			header('Content-Encoding: UTF-8');
 			header('Content-type: text/csv; charset=UTF-8');
 			header("Content-Disposition: attachment; filename=Rezervace.csv");
 			header("Pragma: no-cache");
 			header("Expires: 0");
 			$vystup = fopen("php://output", "w");
 			$delimiter = ";";
 			fputs($vystup, $bom =( chr(0xEF) . chr(0xBB) . chr(0xBF) ));
 			foreach ($data as $radek)
 			{
 				// print_r($radek) ;
 				fputcsv($vystup, $radek, $delimiter);
 			}
 			fclose($vystup);
 			exit();
 		}
 		catch (Chyba $e)
 		{
 			FK::presmerovat();
 		}
 }
 
 
 


}