<?php 
       
class KontrolerRezervaceShrnuti
{

 function __construct()
 {     	
 
  try 
   {
  	
  	//Načíst rezervaci z DB   
 	if(FK::request("editovat"))
 	{ 				
 		$objednavka = N::Rezervace(FK::request("editovat")); 		
 	}
 	//Ještě neuložená objednávka
 	elseif (isset($_SESSION["objednavka"]))
    {    	
    	$objednavka = Rezervace::ziskatZeSession();    	   	
    	
    	if (FK::post("ulozit"))
    	{	
    		 $this->ulozit($objednavka);    		
        }
        elseif (!isset ($_SESSION["objednavka"]["kontakt"]) or !$_SESSION["objednavka"]["kontakt"] or !$objednavka->vratPokojRezervace()->vratPocet())
        {        	
        	throw new Chyba("Nejdříve musí být zadány údaje o ubytování a fakturační údaje");
        }
    } 
    else 
    {
    	throw new Chyba("Rezervace ještě nebyla vytvořena");
    }
    
    
   if (FK::post("generovatFakturu"))
    {    	    	
    	$this->generovatFakturu($objednavka,FK::post("cisloFaktury"));
    }
   elseif (FK::post("generovatDobropis"))
    {    	    	
    	$this->generovatDobropis($objednavka,FK::post("dopropisCenaProcenta"));
    } 
   elseif(FK::post("zobrazitFakturu"))
   {
  	 $this->zobrazitFakturu($objednavka);   
   } 
   elseif(FK::post("zobrazitDobropis"))
   {
   	$this->zobrazitDobropis($objednavka);
   }
   elseif(FK::post("smazatDobropis"))
   {
   	$this->smazatDobropis($objednavka);
   } 
   elseif(FK::post("smazatDobropis"))
   {
   	$this->smazatDobropis($objednavka);
   }
   elseif (FK::get("generovatStravenky"))  
   {
   	$this->generovatStravenky($objednavka);
   }
   elseif (FK::get("zobrazitPotvrzeni"))  
   {
   	$this->zobrazitPotvrzeni($objednavka);
   }
    Kernel::$sablona->assign('objednavka',  $objednavka);
    Kernel::$sablona->assign('kontakt',  $objednavka->vratKontakt());
    Kernel::$sablona->nastavTitulekStranky("Shrnutí rezervace");
    
  }
  catch(Chyba $e)  
  {
  	FK::presmerovat("rezervace");
  }
 
 } 
 
 private function zobrazitPotvrzeni(Rezervace $objednavka)
 {
 	
 	try 
 	{
	 	$dompdf = $this->generovatPotvrzeni($objednavka);
	 	header('Content-type: application/pdf');
	 	echo 	$dompdf->output();
	 	exit();
 	}
	catch(Chyba $e){}	 	
 }
 

 /**
  * Generuje PDF potvrzení o zaplacení ubytování
  * @param Rezervace $objednavka
  * @throws Chyba
  * @return PDF
  */
 private function generovatPotvrzeni(Rezervace $objednavka)
 { 	
 	if (!$objednavka->vratPosledniStavZaplaceni()){
 		throw new Chyba ("Rezervace ještě nebyla zaplacena.");
 	}
 	$sablona = new Sablona();
 	$sablona->assign('objednavka', $objednavka);
 	$sablona->assign('zaplacenaStav', $objednavka->vratPosledniStavZaplaceni());
 	$sablona->assign('kontakt', $objednavka->vratKontakt());
 	$sablona->assign('kolekceNastaveni', Kernel::vratNastaveni()); 	
 	$sablona->nastavHlavicka(false);
 	$sablona->nastavPaticka(false); 	
 	$sablona->nastavTelo('potvrzeni.pdf.tpl');
 	$html = $sablona->fetch();
 	$dompdf = new PDF();
 	$dompdf->load_html($html);
 	$dompdf->render(); 	
 	return $dompdf;  
 }
 
 
 
 /**
  * Vytvořit stravenky použité v rezervaci
  * @param Rezervace $objednavka
  */
 private function generovatStravenky(Rezervace $objednavka)
 { 	
 	try
 	{ 	
 	$snidane = 0;
 	$obed = 0;
 	$vecere = 0;
 	
 	$snidaneDetska = 0;
 	$obedDetska = 0;
 	$vecereDetska = 0;
 	 	
 	foreach ($objednavka->vratStrava() as $strava)
 	{
 		
 		$stravaId = $strava->vratStravaId();
 		$pocet = $strava->vratpocet();
 		
 		//Dospělí - plná penze
 		if ($stravaId == 1)
 		{
 			$snidane = $snidane + $pocet;
 			$obed = $obed + $pocet;
 			$vecere = $vecere + $pocet;
 		}
 		//Dospělí - polopenze
 		elseif ($stravaId == 2)
 		{
 			$snidane = $snidane + $pocet;
 			$vecere = $vecere + $pocet;
 		}
 		//Děti - plná penze
 		elseif ($stravaId == 3)
 		{
 			$snidaneDetska = $snidaneDetska + $pocet;
 			$obedDetska =$obedDetska + $pocet;
 			$vecereDetska = $vecereDetska + $pocet;
 		}
 		//Děti - polopenze
 		elseif ($stravaId == 4)
 		{
 			$snidaneDetska = $snidaneDetska + $pocet; 			
 			$vecereDetska = $vecereDetska + $pocet;
 		}
 	}
 	
 	 Kernel::$sablona->assign("snidane", $snidane);
 	 Kernel::$sablona->assign("obed", $obed);
     Kernel::$sablona->assign("vecere", $vecere);
	 Kernel::$sablona->assign("snidaneDetska", $snidaneDetska);
 	 Kernel::$sablona->assign("obedDetska", $obedDetska);
 	 Kernel::$sablona->assign("vecereDetska", $vecereDetska);
 	 Kernel::$sablona->assign("objednavka", $objednavka);
 	
 	  //vecere 
 	  $interval = DateInterval::createFromDateString('1 day');
      $od = DateTime::createFromFormat("Y-m-d",$objednavka->vratDatumOd());
      $do = DateTime::createFromFormat("Y-m-d",$objednavka->vratDatumDo());      
      $perioda = new DatePeriod($od, $interval, $do); 
 	   Kernel::$sablona->assign("vecerePerioda", $perioda);
 	   	 
 	  //snidane a obed
 	  $interval = DateInterval::createFromDateString('1 day');
 	  $od = DateTime::createFromFormat("Y-m-d",$objednavka->vratDatumOd());
 	  $do = DateTime::createFromFormat("Y-m-d",$objednavka->vratDatumDo());
 	  $perioda = new DatePeriod($od->modify( '+1 day' ), $interval, $do->modify( '+1 day' ));
 	   Kernel::$sablona->assign("snidaneObedPerioda", $perioda);
     
      Kernel::$sablona->nastavHlavicka(false);
      Kernel::$sablona->nastavTelo("stravenky.tpl");
      Kernel::$sablona->nastavPaticka(false);
      }
      catch(Chyba $e)  	{}
 	
 }
 
 
 private function generovatFakturu(Rezervace $objednavka, $cisloFaktury = null)
 {
 	try
 	{ 	
 		$objednavka->kontrolaID();	
 		$objednavka->nastavCisloFaktury($cisloFaktury);
 		$objednavka->ulozit();
 	 		
 		$datumSplatnosti = new DateTime();
 		$datumSplatnosti->modify("+14 days"); 	
 		 		
 		$sablona = new Sablona;	
 		$sablona->nastavHlavicka(false);
 		$sablona->nastavTelo("faktura.pdf.tpl");
 		$sablona->nastavPaticka(false);
 		$sablona->assign('objednavka',  $objednavka);
 		$sablona->assign('kontakt',  $objednavka->vratKontakt()); 
 		$sablona->assign("datumSplatnosti", $datumSplatnosti);
 		$sablona->assign('kolekceNastaveni', Kernel::vratNastaveni());
 		$html = $sablona->fetch(); 	  
 		$dompdf = new PDF(); 		 
 		$dompdf->load_html($html,'UTF-8');
 		$dompdf->render();
 		
 		$output = $dompdf->output();
 		if (!file_put_contents(__DIRFAKTURY__."faktura-".$objednavka->vratId().'.pdf', $output))
 		{
 			throw new Chyba("Došlo k chybě při generování faktury.");
 		}

 		new Potvrzeni("Faktura byla uložena do pdf dokumentu.");
 		FK::presmerovat("?editovat=".$objednavka->vratId());
 	}
 	catch(Chyba $e)  	{}
 }
 
 /**
  * Vygeneruje dobropis a ulozi do pdf
  * @param Rezervace $objednavka
  * @param unknown $dopropisCenaProcenta
  * @throws Chyba
  */
 
 private function generovatDobropis(Rezervace $objednavka, $dopropisCenaProcenta)
 {
 	try
 	{
 		$objednavka->kontrolaID();
 		if (!$objednavka->zjistitExistenciFaktury())
 		{
 			throw new Chyba("Nejdříve musí být vytvořena faktura");
 		}
 		Validace::numeric($dopropisCenaProcenta,"Procentuální částka pro dobropis",array("min" => 0, "max" => 100, "povinny" => true)); 				
 		$dopropisCena = ($objednavka->vratCenaCelkem()*$dopropisCenaProcenta)/100;
 		$objednavka->nastavDobropisCena($dopropisCena); 		
 		$objednavka->ulozit();
 		$sablona = new Sablona;
 		$sablona->nastavHlavicka(false);
 		$sablona->nastavTelo("dobropis.pdf.tpl");
 		$sablona->nastavPaticka(false);
 		$sablona->assign('objednavka',  $objednavka);
 		$sablona->assign('kontakt',  $objednavka->vratKontakt()); 		
 		$sablona->assign('kolekceNastaveni', Kernel::vratNastaveni());
 		$html = $sablona->fetch();
 
 		$dompdf = new PDF();
 		$dompdf->load_html($html);
 		$dompdf->render();
 			
 		$output = $dompdf->output();
 		if (!file_put_contents(__DIRFAKTURY__."dobropis-".$objednavka->vratId().'.pdf', $output))
 		{
 			throw new Chyba("Došlo k chybě při generování dobropisu.");
 		}
 
 		new Potvrzeni("Dobropis byl uložen do pdf dokumentu.");
 		FK::presmerovat("?editovat=".$objednavka->vratId());
 	}
 	catch(Chyba $e)  	{}
 }
 
 private function smazatDobropis(Rezervace $objednavka)
 {
  try
   {
    if (!$objednavka->zjistitExistenciDobropisu())
 		{
 			throw new Chyba("Dobropis k této rezervaci neexistuje");
 		}
 		$objednavka->nastavDobropisCena(0);
 		$objednavka->ulozit();
 		$soubor = __DIRFAKTURY__."dobropis-".$objednavka->vratId().'.pdf';
 		if (unlink($soubor))
 		{
 			new Potvrzeni("Dobropis byl odstraněn.");
 			FK::presmerovat("?editovat=".$objednavka->vratId());
 		}
 		else 
 		{
 			throw new Chyba("Nastala chyba při mazání souboru");
 		} 			
 	}
 	catch(Chyba $e) {}	 	
 }
 
 private function zobrazitFakturu(Rezervace $objednavka)
 {
   try 
   { 
 	if (!$objednavka->zjistitExistenciFaktury())
 	{
 		throw new Chyba("Faktura k této rezervaci neexistuje");
 	} 
 	$soubor = __DIRFAKTURY__."faktura-".$objednavka->vratId().'.pdf';
 	$this->zobrazitPDF($soubor);
   }
   catch(Chyba $e) {} 	
 }
 
 private function zobrazitDobropis(Rezervace $objednavka)
 {
 	try
 	{
 		if (!$objednavka->zjistitExistenciDobropisu())
 		{
 			throw new Chyba("Dobropis k této rezervaci neexistuje");
 		}
 		$soubor = __DIRFAKTURY__."dobropis-".$objednavka->vratId().'.pdf';
 		$this->zobrazitPDF($soubor);
 	}
 	catch(Chyba $e) {}
 }
 
 
 private function zobrazitPDF($soubor)
 {
 	ob_end_clean(); 	
 	header ("Content-Type:application/pdf");
 	$pdf = file_get_contents($soubor);
 	echo $pdf;
 	exit();
 }
 
 private  function ulozit(Rezervace $objednavka)
 {
 	try 
 	{
 		$dostupnost = new Dostupnost($objednavka);
 		$dostupnostStav = $dostupnost->zkontrolujDostupnost();
 		if ($dostupnostStav) 
 		{
 			$objednavka->ulozitVse();
	 		unset($_SESSION["objednavka"]);
	 		FK::presmerovat("?editovat=".$objednavka->vratId());
 		}	
 	}
 	catch(Chyba $e) {}
 }

 
 
 
 
 
 
}