<?php 
       
class KontrolerRezervaceStav
{

 function __construct()
 {  
 	
 	if (FK::post("ulozit"))
 	{
 		$this->pridatStavRezervace(FK::post("stavRezervace"));
  	}
 	elseif(FK::request("editovat"))
 	{
 		$this->formularEditace(FK::request("editovat"));
 	}
 	else 
 	{
 		new Chyba("Nebyla vybrána rezervace");
 		FK::presmerovat(__WEB__);
 	}
 	Kernel::$sablona->nastavTitulekStranky("Stav rezervace");
 	
  }     
      
                                   
   
  private function pridatStavRezervace($stavId)
  {
  	try
  	{
  		$rezervaceId = FK::request("editovat");
  		$rezervace = N::Rezervace($rezervaceId);
  		$stavRezervace = N::StavRezervace();
  		$stavRezervace->nastavRezervaceId($rezervaceId);
  		$stavRezervace->nastavStavId($stavId);
  		$stavRezervace->nastavCas(FK::post("cas"));
  		$stavRezervace->nastavPoznamka(FK::post("poznamka"));
  		
  		$prilohy = array();
  		if (FK::post("informovatZakaznika"))
  		{  
  			if (FK::post("pripojitFakturu"))
	  		{ 	  		
	  			$prilohy[] = "faktura";
	  		}
	  		if (FK::post("pripojitPovrzeniOZaplaceni"))
	  		{	  			
	  			$prilohy[] = "potrzeniOZaplaceni";
	  		}
	  		if (FK::post("pripojitDobropis"))
	  		{
	  			$prilohy[] = "pripojitDobropis";
	  		}	
  		
	  		$this->informujZakaznika($rezervace, $stavRezervace, $prilohy);	  		
  		} 
  		
  		$stavRezervace->ulozit();
  		new Potvrzeni("Změny byly uloženy.");
  		FK::presmerovat("?editovat=".$rezervaceId);
  	}
  	catch (Chyba $e)
  	{  	
  		$this->formularEditace($rezervaceId);
  	}
  
  }
  
  private function formularEditace($rezervaceId)
  {
  	try
  	{
  		$rezervace = N::Rezervace($rezervaceId);
 		Kernel::$sablona->assign('objednavka',  $rezervace); 
 		Kernel::$sablona->assign('stavy',StavRezervace::vratStavy());
 		$dnes = new Datetime();
  	}
  	catch (Chyba $e)
  	{  	
  		FK::presmerovat(__WEB__);
  	}
  
  }

 /**
  * Generuje PDF potvrzení o zaplacení ubytování
  * @param Rezervace $objednavka
  * @throws Chyba
  * @return PDF
  */
 private function generovatPotvrzeni(Rezervace $objednavka, $novyStav = null)
 { 	
 	$posledniStavZaplaceni = ($novyStav->vratStavId() == 3) ? $novyStav :  $objednavka->vratPosledniStavZaplaceni(); 
 	if (!$posledniStavZaplaceni){
 		throw new Chyba ("Rezervace ještě nebyla zaplacena.");
 	} 	
 	$sablona = new Sablona();
 	$sablona->assign('objednavka', $objednavka);
 	$sablona->assign('zaplacenaStav', $posledniStavZaplaceni);
 	$sablona->assign('kontakt', $objednavka->vratKontakt());
 	$sablona->assign('kolekceNastaveni', Kernel::vratNastaveni()); 	
 	$sablona->nastavHlavicka(false);
 	$sablona->nastavPaticka(false); 	
 	$sablona->nastavTelo('potvrzeni.pdf.tpl');
 	$html = $sablona->fetch();
 	$dompdf = new PDF();
 	$dompdf->load_html($html);
 	$dompdf->render(); 	
 	return $dompdf;  
 }
  
  private function informujZakaznika(Rezervace $rezervace,StavRezervace $stavRezervace, $prilohy = array())
  {
  		$mail = new PHPMailerExt();
  		$stavId = $stavRezervace->vratStavId();
  		
  		$sablonaTelo  = new Sablona();
  		$sablonaTelo->nastavHlavicka(false);
  		$sablonaTelo->nastavPaticka(false);
  		$sablonaTelo->nastavTelo("rezervaceStav.email.tpl");
  		$sablonaTelo->assign("rezervace",  $rezervace);
  		$sablonaTelo->assign("kontakt",  $rezervace->vratKontakt());
  		$sablonaTelo->assign ("stavId",$stavId);
  		$sablonaTelo->assign('kolekceNastaveni', Kernel::vratNastaveni());
  		$telo = $sablonaTelo->fetch();  		
	  	
  		$poznamka = null;
  		if (in_array("faktura",$prilohy))
  		{
	  		if (!$rezervace->zjistitExistenciFaktury())
	  		{
	  			throw new Chyba("Faktura k této rezervaci neexistuje");
	  		}
	  		$soubor = __DIRFAKTURY__."faktura-".$rezervace->vratId().'.pdf';	  					
  			$mail->AddAttachment($soubor);
  			$poznamka.= "- Faktura byla přiložena<br>";
  		}
  		if (in_array("potrzeniOZaplaceni",$prilohy))
  		{
  			$potvrzeni = $this->generovatPotvrzeni($rezervace,$stavRezervace)->output();
  			$mail->AddStringAttachment($potvrzeni, "potvrzeni o zaplaceni.pdf");
  			$poznamka.= "- Potvrzení o zaplacení bylo přiloženo<br>";
  		}
  		if (in_array("pripojitDobropis",$prilohy))
  		{
  			if (!$rezervace->zjistitExistenciDobropisu())
	  		{
	  			throw new Chyba("Dobropis k této rezervaci neexistuje");
	  		}
	  		$soubor = __DIRFAKTURY__."dobropis-".$rezervace->vratId().'.pdf';	  					
  			$mail->AddAttachment($soubor);
  			$poznamka.= "- Dobropis byl přiložen<br>";
  		}
  		
  		  		
  		$mail->From     = Kernel::vratNastaveni()->vrat("organizaceEmail")->vratHodnota();
  		$mail->FromName = Kernel::vratNastaveni()->vrat("organizaceNazev")->vratHodnota();  			
  		$mail->AddAddress($rezervace->vratKontakt()->vratEmail());  		
  		
  		$mail->Priority = 1;
  		$mail->IsHTML(true);
  		$mail->Subject  = "Rezervace";
  		$mail->AltBody  = "Pokud chcete zobrazit kompletně tento email, zvolte možnost Zobrazit / Zapnout HTML";   	
  		$mail->MsgHTML($telo);
  		  		
  		if (!$mail->Send())
  		{
  			throw new Chyba("Nepodařilo se odeslat informační e-mail: ".$mail->ErrorInfo);
  		} 
  		
  		$poznamka.= "- Informační e-mail byl odeslán<br>";  		
  		$poznamka = $stavRezervace->vratPoznamka().$poznamka; ;
	  	$stavRezervace->nastavPoznamka($poznamka);
  		
  		new Potvrzeni("Informační email byl odeslán");
  }


}