<?php 
       
class KontrolerRezervaceZakaznik extends Kernel
{

 function __construct()
 {  
  try {
 	
	 	if(isset($_POST["ulozit"]))
	 	{
	 	 $objednavka = N::Rezervace(FK::post("ulozit")); 
	 	 $this->ulozit($objednavka);
		}
	 	elseif(FK::request("editovat"))
	 	{
	 		//Načíst rezervaci z DB 	
	 		$objednavka = N::Rezervace(FK::request("editovat")); 		
	 	} 	
	 	elseif (isset($_SESSION["objednavka"]))
	    {
	        //pokračovat v objednávce
	        $objednavka = Rezervace::ziskatZeSession(); 
	    }     
	    else
	    {    	   	
	    	$objednavka = new Rezervace();
	    	$objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace')); // zruseni callback fce
	    } 
	              
	    if (FK::post("vybratZakaznika"))
	    {
	    	$this->vybratZakaznika($objednavka,FK::post("vybratZakaznika"));
	    }
	    elseif (FK::post("pokracovat"))
	    {
	     	 $this->pokracovat($objednavka);
	    } 
 
      
    //////////////////////////////////////////////////////
      
    $kolekceZakazniku =  new Kolekce("Zakaznik");
    Zakaznik::kolekceVsech($kolekceZakazniku);
    
    Kernel::$sablona->assign('kolekceZakazniku', $kolekceZakazniku);     
    Kernel::$sablona->assign('objednavka', $objednavka);    
    Kernel::$sablona->assign('staty', Kontakt::vratStaty());
    Kernel::$sablona->assign('kontakt',  $objednavka->vratKontakt());
    Kernel::$sablona->nastavTitulekStranky("Fakturační údaje");
   
  }
  catch(Chyba $e){
  	FK::presmerovat(__WEB__);
  }
  
  }    
    
    /**
     * nastaví kontakt v rezervaci stejný, jako u vybraného zákazníka
     * při vytváření rezervace ukládá do session a nastavuje session
     * @param Rezervace $objednavka
     * @param string $zakaznikId
     */
  
    private function vybratZakaznika(Rezervace $objednavka,$zakaznikId) 
    {
      try
      { 
      	$zakaznik = N::Zakaznik($zakaznikId);    	
    	$objednavka->nastavKontakt(clone $zakaznik->vratKontakt());  
    	$objednavka->vratKontakt()->nastavId(null);
    	//zrušit id -> kontakt ještě nebyl uložen
    	$objednavka->nastavZakaznikId($zakaznik->vratId()); 
    	if (!$objednavka->vratId())
    	{
    		$_SESSION["objednavka"]["kontakt"] = true;
    		$objednavka->ulozitDoSession();
    		FK::presmerovat();
    	}  	
    	
      }
      catch(Chyba $e){}
    }
    
    /**
     * nastavuje kontaktní informace k rezervaci
     * při vytváření rezervace nastavuje session podle úpěchu metody
     * @param Rezervace $objednavka
     * @throws Chyba
     */
    private function nastavKontakt(Rezervace $objednavka)
    {  
    	$chyba = false;
    	$kontakt = $objednavka->vratKontakt();
    	try{ $kontakt->nastavEmail(FK::post("email")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavJmeno(FK::post("jmeno")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavPrijmeni(FK::post("prijmeni")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavMesto(FK::post("mesto")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavCisloPopisne(FK::post("cisloPopisne")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavSmerovaciCislo(FK::post("smerovaciCislo")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavUlice(FK::post("ulice")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavTelefon(FK::post("telefon")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavStatId(FK::post("stat")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavIco(FK::post("ico")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavDic(FK::post("dic")); } catch(Chyba $e)  {$chyba = true;}
    	try{ $kontakt->nastavOrganizace(FK::post("organizace")); } catch(Chyba $e)  {$chyba = true;}    	
    	
    	if (!$objednavka->vratId()){
    		$_SESSION["objednavka"]["kontakt"] = !$chyba;
    	}    	
    	if ($chyba) 
    	{    		
    		throw new Chyba("Nebyly správně vyplněny všechny povinné údaje");
    	}
    }
    
    /**
     * ukládá do session změny v kontaktu
     * @param Rezervace $objednavka
     */
    
    private function pokracovat(Rezervace $objednavka)
    {
    	try
    	{  
    		$this->nastavKontakt($objednavka);
    		$objednavka->ulozitDoSession();    		
    		FK::Presmerovat("rezervaceShrnuti");
    	}
    	catch(Chyba $e)  
    	{    		
    		$objednavka->ulozitDoSession();
    		FK::Presmerovat();
    	}
    }
        
    /** 
     * ukládá do db změny v kontaktu 
     * pouze při editaci vytvořené rezervace 
     * @param unknown $id
     * @throws Chyba
     */
    
    private function ulozit(Rezervace $objednavka)
    {   
      try
       { 
    	if (!$objednavka->vratId())
    	{
    		throw new Chyba("Tuto operaci nelze provést");
    	}
    	        
    	$this->nastavKontakt($objednavka);   
       	$objednavka->vratKontakt()->ulozit();
       	new Potvrzeni("Údaje byly uloženy.");
       	FK::presmerovat("?editovat=".$objednavka->vratId());  
       }      
       catch(Chyba $e)  {}
    }
 
     

}