<?php
class Statistika extends BO2
 {	
 	protected $pocetHostuCelkem = 0;
 	protected $pokojdny = 0;
 	protected $pocetPrenocovani = 0; 
 	protected $datumOd = null;
 	protected $datumDo = null;
 	 	
 	function __construct(DateTime $statistikaOd,DateTime $statistikaDo)
 	{
 		
 		//zahrnutí noci na koci měsíce
 		$statistikaDo->modify("+1 day"); 
 	   
	 	$this->datumOd = $statistikaOd->format("d.m.Y");
	 	$this->datumDo = $statistikaDo->format("d.m.Y");
	 
	 	$kolekceRezervaci = new RezervaceFiltr();
	 	$kolekceRezervaci->nastavDatumOd($this->datumOd);
	 	$kolekceRezervaci->nastavDatumDo($this->datumDo);
	 	$kolekceRezervaci->nastavPriNenalezeni("return");
	 	$kolekceRezervaci->nastavStavId(3);      //jen zaplacené
	 	
	 	foreach ($kolekceRezervaci as $rezervace)
	 	{	 			 
	 		$od = DateTime::createFromFormat("Y-m-d", $rezervace->vratDatumOd());
	    	$do = DateTime::createFromFormat("Y-m-d", $rezervace->vratDatumDo());
	    	
	    	//pocet hostů
	    	//započítává se jen když rezervace vznikla v tomto období 
	    	if ($od >= $statistikaOd){
	    		$this->pocetHostuCelkem =  $this->pocetHostuCelkem + $rezervace->vratPocetHostu();
	    	}
	    	
	    	///počet noci
	    	$od = ($od > $statistikaOd) ? $od : $statistikaOd;
	    	$do = ($do < $statistikaDo) ? $do : $statistikaDo;   	    	
	   
	    	
	 		$y1 = $do->format('Y');
	 		$y2 = $od->format('Y');
	 		$z1 = $do->format('z');
	 		$z2 = $od->format('z');
	 		$pocetNoci = intval($y1 * 365.2425 + $z1) - intval($y2 * 365.2425 + $z2);
	
	 	    $this->pocetPrenocovani =  $this->pocetPrenocovani + ($pocetNoci * $rezervace->vratPocetHostu()) ;
	 	
	 	    ///počet pokojů
	 	    $pocetPokoju = $rezervace->vratPokojRezervace()->vratPocet();	 	    
	 	    $this->pokojdny =    $this->pokojdny + $pocetPokoju * $pocetNoci;	 	  
	 	   
 	}   
 	} 
 }   