<?php

class BlokovaniRezervace Extends BO2
 {
  
  protected $id = null;
  protected $datumOd = null; 
  protected $datumDo = null; 
  
  protected static $tabulkaDB = "blokovani_rezervace";
  protected static $mapovaniDB = array ( 
   "id" => "id_blokovani_rezervace",   
   "datumOd" => "datum_od",
   "datumDo"  => "datum_do" 
   );
  
  protected static $kolekce;
  
	function __construct($id=null)
	{  			
	   parent::__construct($id);
	}	
  
   public function nastavDatum($od,$do,$format)
  {    
     Validace::datum($od,$format);
     Validace::datum($do,$format);
     $od = DateTime::createFromFormat($format, $od);
     $do = DateTime::createFromFormat($format, $do);          
         
     if ($od > $do)
     {
         Throw new Chyba("Blokování rezervace může být pouze v rámci jednoho kalendářního roku.");
     }
    
     $this->datumOd = $od->format("Y-m-d");
     $this->datumDo = $do->format("Y-m-d"); 
  }
 
  public static function filtr($kolekce,$datumOd,$datumDo)
  {
  	Validace::datum($datumOd, $format = 'Y-m-d');
  	Validace::datum($datumDo, $format = 'Y-m-d');
  
  	$od = DateTime::createFromFormat('Y-m-d', $datumOd);
  	$do = DateTime::createFromFormat('Y-m-d', $datumDo);
  
  	/*$parametry["datumOdDen"] = $od->format("d");
  	$parametry["datumOdMesic"] = $od->format("m");
  	$parametry["datumDoDen"] = $do->format("d");
  	$parametry["datumDoMesic"] = $do->format("m");*/
  	
    	
  	
  	if ($od->format("m-d") > $do->format("m-d"))
  	{
  		$parametry["datumDo"] = $do->format("0001-m-d");
  		$parametry["datumOd"] = $od->format("0000-m-d");
  	}
  	else 
  	{  		
  		$parametry["datumDo"] = $do->format("0001-m-d");
  		$parametry["datumOd"] = $od->format("0001-m-d");
  	}
  	

  	$dotaz = "SELECT ". self::$mapovaniDB["id"]." FROM ". self::$tabulkaDB ." WHERE  			
  	(DATE_FORMAT(datum_do,'0001-%m-%d') >= :datumOd AND  DATE_FORMAT(datum_od,'0001-%m-%d') <= :datumDo)";
  	
  	
  	/*$dotaz = "dSELECT ". self::$mapovaniDB["id"]." FROM ". self::$tabulkaDB ." WHERE
  	
  			((DATE_FORMAT(datum_od,'%m-%d') BETWEEN :datumOd AND :datumDo) OR
  	         (DATE_FORMAT(datum_do,'%m-%d') BETWEEN :datumOd AND :datumDo))";*/
  
  	/*$dotaz = "SELECT ". self::$mapovaniDB["id"]." FROM ". self::$tabulkaDB ." WHERE
 	
  			((:datumOd BETWEEN DATE_FORMAT(datum_od,'%m-%d') AND DATE_FORMAT(datum_do,'%m-%d')) OR
  	        (:datumDo BETWEEN DATE_FORMAT(datum_od,'%m-%d') AND DATE_FORMAT(datum_do,'%m-%d')))";*/
  	   
  	/*$dotaz = "SELECT ". self::$mapovaniDB["id"]." FROM ". self::$tabulkaDB ." WHERE
 	(MONTH(datum_do) >= :datumOdMesic AND DAYOFMONTH(datum_do) >= :datumOdDen) AND
 	(MONTH(datum_od) <= :datumDoMesic AND DAYOFMONTH(datum_od) <= :datumDoDen)";*/
  	//.self::$mapovaniDB["datumDo"] ." >= :datumOd AND " .self::$mapovaniDB["datumOd"] ." <= :datumDo";
  	
  	
  	
  	
  
  
  
  	self::Kolekce($kolekce,DB::dotazJedenSloupec($dotaz,$parametry),null,array());
  }
	
 }