<?php
class Dostupnost extends Accessor
{ 
	protected $objednavka = null;
	protected $kolekceSkupinPokoju = null;
   	protected $volnoBezRezervace = array();
   	protected $volnoSRezervaci = array();
   	protected $od = null; //Datetime
   	protected $do = null; //Datetime
   	protected $automatickyVyberPokoju = true;
   	protected $vybranePokoje = null; // array(pokojId => počet hostů)
   	protected $vybraneSkupinyPokoju = null; // array (skupinaPokojuId => array (počet hostů => počet pokojů))
   	protected $obsazenoVRezervaci = null;
   
   	
   	
   	
   	function __construct(Rezervace $objednavka)
   	{
   	
   		$this->objednavka = $objednavka;
   		$this->kolekceSkupinPokoju  = new Kolekce();
   		SkupinaPokoju::kolekceVsech($this->kolekceSkupinPokoju);
   		 
   		//vytvořit kolekce pokojů ve skupině
   		foreach  ($this->kolekceSkupinPokoju as $skupinaPokojuId => $skupinaPokoju)
   		{
   			$skupinaPokoju->vratPokoje()->vratPolozky();
   			$kolekcePokojuVeSkupine = clone $skupinaPokoju->vratPokoje();
   			foreach ($kolekcePokojuVeSkupine as $pokoj)
   			{
   				if ($pokoj->vratStavId() == 3)
   				{
   					$kolekcePokojuVeSkupine->odstran($pokoj->vratId());
   				}
   					
   			}
   			
   			$this->volnoBezRezervace[$skupinaPokojuId] = clone $kolekcePokojuVeSkupine;
   			$this->volnoSRezervaci[$skupinaPokojuId] = clone $kolekcePokojuVeSkupine;
   		}
   		
   		$format = "Y-m-d";
   		$this->od = DateTime::createFromFormat($format, $objednavka->vratDatumOd());
   		$this->do = DateTime::createFromFormat($format, $objednavka->vratDatumDo());
   		
   	}	
  
      

  public function zkontrolujDostupnost()
   {
   	$stav = true;
       
    //Zjistit, jestli nejsou rezervace v tomto termínu zablokovány
    $kolekceBlokovaniRezervace = new kolekce("BlokovaniRezervace");  	
    BlokovaniRezervace::filtr($kolekceBlokovaniRezervace ,$this->objednavka->vratDatumOd(),$this->objednavka->vratDatumDo());
    if ($kolekceBlokovaniRezervace->vratPocet())
    {   
    	Kernel::$sablona->assign('blovaniRezervace',true);    	
    	new Chyba("V tomoto termínu nejsou rezervace povoleny");
    	$this->volnoBezRezervace = array();
    	$this->volnoSRezervaci = array();
    	return false;
    }
 
	//omezení pro frontend
    if (!defined("__SEKCE__") or __SEKCE__!="administrace")
    {   	  
    	
    	//Zkontrolovat jestli objednávka není vytvářena na moc vzdálené období 
    	$max = new DateTime();
   	    $max->modify(Kernel::vratNastaveni()->vrat("povolitRezervaceDopredu")->vratHodnota()." day");    
    	if ($this->do > $max and (!defined("__SEKCE__") or __SEKCE__!="administrace"))
   		 {
	    	new Chyba("Není možné vytvořit rezervaci na takto vzdálené období.");    
	    	$this->objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace'));
	    	return false;
   		 }	
   		 
   		//Zkontrolovat jestli objednávka není vytvářena na minulé období
   		$min = new DateTime();
   		 if ($this->od < $min)
   		 {
   		 	$this->objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace'));
   		 	new Chyba("Není možné vytvořit rezervaci proběhlé období.");
   		 	return false;
   		 }
    }
    
  
    
    //vytvořit kolekci pokojů ve skupině, ve které jsou jen pokoje, které nejsou v době rezervace obsazené
    if ($this->od and $this->do)
    {  
    	$kolekceRezervaci = new RezervaceFiltr();  
    	
    	//nezapočítávat poslední den, vytvořených rezervací,  protože to už je možné vytvářet další rezervaci
    	$this->od->modify( '+1 day' );
    	$this->do->modify( '-1 day' );
    
    	$kolekceRezervaci->nastavDatumOd($this->od->format("d.m.Y"));
    	$kolekceRezervaci->nastavDatumDo($this->do->format("d.m.Y"));
    	$kolekceRezervaci->nastavpriNenalezeni("return");
    	$stavy = StavRezervace::vratStavy();
    	unset($stavy[10]); // bez stornovaných
    	$kolekceRezervaci->nastavStavId(array_flip($stavy));
	
	      //vytvořit kolekci volných pokojů ve skupině	      
	      foreach ($kolekceRezervaci as $rezervace)
	      { 
	      	if ($rezervace->vratId() == $this->objednavka->vratId()) continue; //nezahrnout editovanou rezervaci	         	
	         
	      	 foreach ($rezervace->vratPokojRezervace() as $pokojRezervace)
	         {
	             $skupinaPokojuId = $pokojRezervace->vratPokoj()->vratSkupinaPokojuId(); 
	             $pokojId = $pokojRezervace->vratPokoj()->vratId();  
	             if ($this->volnoBezRezervace[$skupinaPokojuId]->existuje($pokojId))
	             {	             	 
	             	$this->volnoBezRezervace[$skupinaPokojuId]->odstran($pokojId);
	             	$this->volnoSRezervaci[$skupinaPokojuId]->odstran($pokojId);
	             }	            
	         }
	      }
    }
      
   
    //vybrane pokoje byly změněny
    if (is_array($this->vybranePokoje) or is_array($this->vybraneSkupinyPokoju))
    {
    	//vymazat původní pokoje z rezervace
    	$this->objednavka->nastavPokojRezervace(new Kolekce('PokojRezervace'));

		 
		    /*oveřit jestli jsou vybrané pokoje volné*/ 
		    //automatický výběr pokojů je vypnut   
		    if (!$this->automatickyVyberPokoju)
		    {
		    	
		    	//byly vybrány nějaké pokoje
		    	if ($this->vybranePokoje)
		    	{ 
			    	foreach ($this->vybranePokoje as $pokojId => $pocetHostu)
			    	{    		
			    		
			    	 try
			    	  {	
			    		$pokoj = N::Pokoj($pokojId);
			    		$skupinaPokojuId = $pokoj->vratSkupinaPokojuId();
			    		if (!in_array($pokojId, $this->volnoSRezervaci[$skupinaPokojuId]->vratKlice()))
			    		{
			    			throw new Chyba("Pokoj '".$pokoj->vratNazev()."' již není volný");
			    		}    		
			    		$this->volnoSRezervaci[$skupinaPokojuId]->odstran($pokoj->vratId());
			    		$this->objednavka->pridatPokojRezervace($pokoj->vratId(),$pocetHostu);
			    	  }
			    	  catch(Chyba $e)
			    	  {
			    	  	$stav = false;
			    	  	break;
			    	  }
			    		
			    	}
		    	}	
		    }
		    
		    //automatický výběr pokojů je zapnut
		    else
		    { 
		    	//$sp není nastaven -> vytvořit z po
		    	if (!$this->vybraneSkupinyPokoju)
		    	{
			    	foreach ($this->vybranePokoje as $pokojId => $pocetHostu)
			    	{
			    		$pokoj = N::Pokoj($pokojId);
			    		$skupinaPokojuId = $pokoj->vratSkupinaPokojuId();
			    		if (!isset($this->vybraneSkupinyPokoju[$pokoj->vratSkupinaPokojuId()][$pocetHostu])) {
			    			$this->vybraneSkupinyPokoju[$pokoj->vratSkupinaPokojuId()][$pocetHostu] = 0;
			    		}
			    		$this->vybraneSkupinyPokoju[$pokoj->vratSkupinaPokojuId()][$pocetHostu] ++;
			    	}    
		    	}
		   
				 foreach ($this->vybraneSkupinyPokoju as $skupinaPokojuId => $arr)
				  {          
				    foreach ($arr as $pocetHostu => $pocetPokoju)
				     {
				       for ($i=1; $i<=$pocetPokoju; $i++) 
				         {
				                try
				                  {                  
				                    //je ve skupině pokojů ješte nejaký volný pokoj?
				                    if (!$this->volnoSRezervaci[$skupinaPokojuId]->vratPocet())
				                    {
				                        throw new Chyba("Pokoj již není volný");
				                    } 
				                                                                       
				                    $pokoj = $this->volnoSRezervaci[$skupinaPokojuId]->vratPrvni();
				                    $this->volnoSRezervaci[$skupinaPokojuId]->odstran($pokoj->vratId());                    
				                    $this->objednavka->pridatPokojRezervace($pokoj->vratId(),$pocetHostu); 
				                  }
				                  catch(Chyba $e)
				                  {
				                  	$stav = false;
				                  	break;
				                  }  
				                   
				            }
				          }   
				       }
		      }

    }	
	//z formuláře nebyly odeslány žádné vybrané pokoje, použít původní
	elseif ($this->objednavka->vratPokojRezervace()->vratPocet())
	{		
		foreach ($this->objednavka->vratPokojRezervace() as $pokojRezervace)
		{
		 try
		  {
		  	$pokojId = $pokojRezervace->vratPokojId();
		  	$skupinaPokojuId = $pokojRezervace->vratPokoj()->vratSkupinaPokojuId();
			if (!in_array($pokojId, $this->volnoSRezervaci[$skupinaPokojuId]->vratKlice()))
			{
				throw new Chyba("Pokoj '".$pokojRezervace->vratPokoj()->vratNazev()."' již není volný");
			}
			$this->volnoSRezervaci[$skupinaPokojuId]->odstran($pokojId);
		  }
		catch(Chyba $e)
		  {
			$stav = false;
			break;
		 }
		}
	}
      
   
   return $stav;
   } 
      
    public function vratObsazenoVRezervaci()
    { 
      //vytvorit kolekci pokoju vybranych v teto objednavce
      if ($this->obsazenoVRezervaci === null)
      {      
      	 $this->obsazenoVRezervaci = array();
      	 foreach ($this->objednavka->vratPokojRezervace() as $pokojRezervace)
	      {
	      	$pokoj = $pokojRezervace->vratPokoj();
	      	if (!isset($this->obsazenoVRezervaci[$pokoj->vratSkupinaPokojuId()][$pokojRezervace->vratPocetHostu()]))
	      	{
	      		$this->obsazenoVRezervaci[$pokoj->vratSkupinaPokojuId()][$pokojRezervace->vratPocetHostu()] = new Kolekce("Pokoj");
	      	}
	      	$this->obsazenoVRezervaci[$pokoj->vratSkupinaPokojuId()][$pokojRezervace->vratPocetHostu()]->pridej($pokoj);
	      } 
      }      
     return $this->obsazenoVRezervaci; 
    } 
    
   }
