<?php

class Kalendar Extends Accessor
 {
  
  protected $id = null;
  protected $datumOd = null; //Y-m-d
  protected $datumDo = null; //Y-m-d
  
  //kolekce rezervací v rozsahu datumOd datumDo
  protected $rezervace = null;
  //kolekce blokovaniRezervaci v rozsahu datumOd datumDo
  protected $blokovaniRezervace = null;
  
  /**
   * $denSkupinaObsazeno["$datum (Y-m-d) "][$skupinaPokojuId][$castDne] = počet obsazených pokojů
   * vytvářené jen tam, kde je nějaké rezervace
   * nezapočítávají se zablokované pokoje
   */ 
  
  protected  $denSkupinaObsazeno  = array(); 
  
  /**
   * $denBlokovano[$datum (m-d)] = true
   * jen pro dny, které jsou zablokované
   */
  
  protected  $denBlokovano  = array();
  
  /**
   * denPokoj[$datum (Y-m-d)][$pokojId][$castDne]["hostu"] = počet hostů
   * denPokoj[$datum (Y-m-d)][$pokojId][$castDne]["rezervace"] = rezervace (obj)
   */
  
  protected  $denPokoj = array();
    
  /**
   * skupinaBlokovanoPokoju[$skupinaPokojuId] = počet zablokovaných pokojů 
   */
  protected $skupinaBlokovanoPokoju = array();
  
  /**
   * datumPulden["$datum (Y-m-d)"]
   * pro validní výstup - jestli je ve sloupci rozdělená buňka
   */
  protected $datumPulden = array();

  
  
  function __construct($od,$do,$format)
  {
  	$this->nastavDatum($od,$do,$format);
    
  	$this->blokovaniRezervace = new Kolekce("BlokovaniRezervace");
  	$this->blokovaniRezervace->nastavCallback('kolekceBlokovaniRezervace', $this); 
  }
  
  public function vratSloupce()
  {
      $interval = DateInterval::createFromDateString('1 day');
      $od = DateTime::createFromFormat("Y-m-d",$this->datumOd);
      $do = DateTime::createFromFormat("Y-m-d",$this->datumDo);      
      $period = new DatePeriod($od, $interval, $do->modify( '+1 day' )); 
      return $period;
  }
  
  public function init()
  {  	  
  	
  	//vytvořit pole skupinaBlokovanoPokoju
  	$kolekceVsechPokoju  = new Kolekce();
  	Pokoj::kolekceVsech($kolekceVsechPokoju);  	
  	foreach ($kolekceVsechPokoju as $pokoj)
  	{
  		if ($pokoj->vratStavId() == 3)
  		{
  			if (isset ($this->skupinaBlokovanoPokoju[$pokoj->vratSkupinaPokojuId()])){
  				$this->skupinaBlokovanoPokoju[$pokoj->vratSkupinaPokojuId()] ++;	
  			}else{
  				$this->skupinaBlokovanoPokoju[$pokoj->vratSkupinaPokojuId()] = 1;
  			}
  			
  			
  		}
  	}  	
  	
  	$odKalendar = DateTime::createFromFormat("Y-m-d",$this->vratDatumOd());
  	$doKalendar = DateTime::createFromFormat("Y-m-d", $this->vratDatumDo());
  	$rezervaceFiltr = new RezervaceFiltr();
  	$rezervaceFiltr->nastavDatumOd($odKalendar->format("d.m.Y"));
    $rezervaceFiltr->nastavDatumDo($doKalendar->format("d.m.Y"));
  	$stavy = StavRezervace::vratStavy();
    unset($stavy[10]); // bez stornovaných
    $rezervaceFiltr->nastavStavId(array_flip($stavy));
  	$rezervaceFiltr->nastavPriNenalezeni("return");
  	$this->rezervace = $rezervaceFiltr->vratPolozky();
  
    	  	
  	//vytvořit pole den pokoj
  	foreach ($this->rezervace as $rezervace)
      {     
      $interval = DateInterval::createFromDateString('1 day');
      $odRezervace = DateTime::createFromFormat("Y-m-d",$rezervace->vratDatumOd());
      $doRezervace = DateTime::createFromFormat("Y-m-d",$rezervace->vratDatumDo());

      //vytvořit rozsah jen pro dny zobrazené v kalendáři
      $od = ($odRezervace >  $odKalendar) ? $odRezervace : $odKalendar;
      $do = ($doRezervace <  $doKalendar) ? $doRezervace : $doKalendar;
            
      $perioda = new DatePeriod($od, $interval, $do->modify( '+1 day' )); 
       
       foreach ($perioda as $datum )
           {         
           	$datum  = $datum->format( "Y-m-d" );
                  
              foreach ($rezervace->vratPokojRezervace() as $pokojRezervace)
              {
                           	 
              	//na jakou část dne se rezervace vztahuje 
              	if ($rezervace->vratDatumOd() == $datum) {
              		$castDne = "odpoledne";
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["odpoledne"]["hostu"] = $pokojRezervace->vratPocetHostu();
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["odpoledne"]["rezervace"] = $rezervace; 
              		$this->datumPulden[$datum] = true;
              	 }              	 
              	elseif ($rezervace->vratDatumDo() == $datum) {
              		$castDne = "dopoledne";
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["dopoledne"]["hostu"] = $pokojRezervace->vratPocetHostu();
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["dopoledne"]["rezervace"] = $rezervace;
              		$this->datumPulden[$datum] = true;
              	}
              	else
              	{
              		$castDne = "cely";
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["dopoledne"]["hostu"] = $pokojRezervace->vratPocetHostu();
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["dopoledne"]["rezervace"] = $rezervace;
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["odpoledne"]["hostu"] = $pokojRezervace->vratPocetHostu();
              		$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()]["odpoledne"]["rezervace"] = $rezervace;
              	}
              		
              	$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()][$castDne]["hostu"] = $pokojRezervace->vratPocetHostu();
              	$this->denPokoj[$datum][$pokojRezervace->vratPokoj()->vratId()][$castDne]["rezervace"] = $rezervace; 
                $pokoj = $pokojRezervace->vratPokoj();                
                 
				//nevytvářet pro pokoje s blokovanou rezervací
                 if ($pokoj->vratStavId() != 3)
                 {
                 	$skupinaPokojuId = $pokoj->vratSkupinaPokojuId();
                 	if ($castDne == "odpoledne")
                 	{
                 		$this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"] = isset($this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"])? $this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"]+1 : 1;  
                 	}
                 	elseif ($castDne == "dopoledne")
                 	{
                 		$this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"] = isset($this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"])? $this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"]+1 : 1;
                 	}
                 	else
                 	{
                 		$this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"] = isset($this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"])? $this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["dopoledne"]+1 : 1;
                 		$this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"] = isset($this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"])? $this->denSkupinaObsazeno[$datum][$skupinaPokojuId]["odpoledne"]+1 : 1;
                 	}
                 }           
              }
           }   
      } 
      
      //vytvořit pole dnů, ve kterých jsou rezervace zablokovány      
      foreach ($this->vratBlokovaniRezervace() as $blokovaniRezervace)
      {
      	$interval = DateInterval::createFromDateString('1 day');
      	$od = DateTime::createFromFormat("Y-m-d",$blokovaniRezervace->vratDatumOd());
      	$do = DateTime::createFromFormat("Y-m-d",$blokovaniRezervace->vratDatumDo());
      	$perioda = new DatePeriod($od, $interval, $do->modify( '+1 day' ));
      	
      	foreach ($perioda as $datum)
      	{
      		$datum  = $datum->format( "m-d");
      		$this->denBlokovano[$datum] = true;
      	}
      }
    } 
		
		
  /**
   * Nastavuje rozsah kalendáře. Při chybném zadání nastaví výchozí hodnoty
   * @param string $od
   * @param string $do
   * @param string $format 
   */
  public function nastavDatum($od,$do,$format)
  { 
  	 try 
  	 {  	
	  	 Validace::datum($od,$format);
	     Validace::datum($do,$format);
	     $od = DateTime::createFromFormat($format, $od);
	     $do = DateTime::createFromFormat($format, $do);          
	     $pocetDni = FK::pocetNoci($od,$do) +1;
	   
	     if ($pocetDni < 1)
	     {
	         Throw new Chyba("Datum je ve špatném formátu.");
	     }	     
	     if ($pocetDni > 366)
	     {
	     	Throw new Chyba("Nelze zobrazit kalendář na dobu delší než jeden rok.");
	     }
	     $this->datumOd = $od->format("Y-m-d");
	     $this->datumDo = $do->format("Y-m-d"); 
  	 }
  	 catch (Chyba $e)
  	 {
  	 	$dnes = new Datetime();
  	 	$rozsahOd = $dnes;
  	 	$dnes = new Datetime();
  	 	$rozsahDo = $dnes->modify('+1 month');
  	 	$this->datumOd = $rozsahOd->format("Y-m-d");
  	 	$this->datumDo = $rozsahDo->format("Y-m-d");
  	 }
     
  }
  
 
   
 public function kolekceBlokovaniRezervace($kolekce)
  {
    BlokovaniRezervace::filtr($kolekce,$this->vratDatumOd(),$this->vratDatumDo()); 
  } 
  
}