<?php
class Kontakt extends BO2
{
  
 protected $id = null;
 protected $email = null;
 protected $jmeno = null;
 protected $prijmeni = null;
 protected $ulice =  null;
 protected $mesto =  null;
 protected $cisloPopisne =  null;
 protected $smerovaciCislo =  null;
 protected $telefon = null;
 protected $statId = null;
 protected $ico = null;
 protected $dic = null;
 protected $organizace = null;

 
 protected static $kolekce = null;

 protected static $tabulkaDB = "kontakt";
  protected static $mapovaniDB = array ( 
   "id" => "id_kontakt",
   "email" => "email",
   "jmeno"  => "jmeno",
   "prijmeni" => "prijmeni",
   "ulice" => "ulice",
   "mesto" => "mesto",
   "cisloPopisne" => "cp",
   "smerovaciCislo" => "psc",
   "telefon" => "telefon",
   "statId" => "id_stat",
   "ico" => "ico",
   "dic" => "dic",
   "organizace" => "organizace",  
   );
  
 
  protected static $staty = array (1=>"Česká republika",2=>"Slovenská republika");
  
   
 function __construct($id=null)
 {
 	parent::__construct($id);
 }
 
   
  public function nastavEmail($email)
 { 
     if ($email){
     	Validace::email($email);  
     }
	 $this->email = $email;
 }
 
 public function nastavJmeno($jmeno)
 {
 	Validace::delka($jmeno,1,50,'Jméno');
 	$this->jmeno = $jmeno;
 }
 
 public function nastavPrijmeni($prom)
 {
 	Validace::delka($prom,1,50,'Příjmení');
 	$this->prijmeni = $prom;
 }
 
 public function nastavUlice($prom)
 {
 	Validace::delka($prom,1,50,'Ulice');
 	$this->ulice = $prom;
 }
 
 public function nastavMesto($prom)
 {
 	Validace::delka($prom,1,70,'Město');
 	$this->mesto = $prom;
 }
 
 public function nastavCisloPopisne($prom)
 {
 	Validace::delka($prom,1,15,'Číslo popisné');
 	$this->cisloPopisne = $prom;
 }
 
 public function nastavSmerovaciCislo($prom)
 {
 	Validace::delka($prom,1,5,'Směrovací číslo'); 
 	$this->smerovaciCislo = $prom;
 }
 
 public  function nastavTelefon($prom)
 { 	
 	Validace::telefon($prom,array("povinny" => false));
 	$this->telefon = $prom;
 }
 
 public  function nastavStatId($prom)
 {
 	self::existujeStat($prom);
 	$this->statId = $prom;
 } 
 
 public  function nastavOrganizace($prom)
 {
 	Validace::delka($prom, 0, 100, "Název organizace");
 	$this->organizace = $prom;
 }
 public  function nastavIco($prom)
 {
 	Validace::delka($prom, 0, 10, "Ičo");
 	$this->ico = $prom;
 }
 public  function nastavFirmaDic($prom)
 {
 	Validace::delka($prom, 0, 10, "Dič");
 	$this->dic = $prom;
 }
 
 
 
 public static function existujeStat($statId)
 {
 	if (!isset(self::$staty[$statId]))
 	{
 		throw new Chyba ("Tento stát neexistuje");
 	}
 }
 
 public function vratStat()
 { 	
 	if ($this->statId)
 	return self::$staty[$this->statId];
 	
 	
 }
 
 
}

