<?php

class PokojRezervace Extends BO2
 {
  
  protected $id = null;
  protected $pokojId = null;
  protected $rezervaceId = null; 
  protected $pocetHostu = null;
  protected $cena = null;
  
  protected $rezervace = null; 
  
  protected static $kolekce;

  
  protected static $tabulkaDB = "pokoj_rezervace";
  protected static $mapovaniDB = array ( 
   "id" => "id_pokoj_rezervace",
   "pokojId" => "id_pokoj",
   "rezervaceId"  => "id_rezervace",
   "pocetHostu" => "pocet_hostu",
    "cena" => "cena"    
   );
  
		
	public function __construct($id=null)
	{  			
		  parent::__construct($id);
	}	
  
  public function vratPokoj()
  {
    return N::Pokoj($this->pokojId);
  }
  
  public function vratRezervace()  
  { 
    if (!$this->rezervace)
    $this->rezervace = N::Rezervace($this->rezervaceId);
    return  $this->rezervace;  
  }      
  
  public function nastavRezervace(Rezervace $obj)
  {
    $this->rezervace = $obj;
  }
  
  public function vratCena()
  {
  	if (!$this->id)
  	{
  		$this->cena = $this->vypocitejCenu();
  	}
  	return $this->cena;  	
  }
  
  
  
  public function vypocitejCenu()
  {
    $cena =  $this->vratPokoj()->vratSkupinaPokoju()->vratCenaZaNoc($this->pocetHostu) *  ($this->vratRezervace()->vratPocetNoci()); 
    return $cena;
  }
  
  
  public function nastavPocetHostu($prom)
  {
     $this->kontrolaAtributu("pokojId");
     if ($prom > $this->vratPokoj()->vratSkupinaPokoju()->vratPocetLuzek())
     {
       throw new Chyba("V pokoji není dostatečný počet lůžek");
     }
     $this->pocetHostu = $prom;
  }
  
  public function ulozit()
  {
  	$this->vratCena();
  	$this->rezervaceId = $this->vratRezervace()->vratId();
  	parent::ulozit();
  }
  
  
  
  
  
  
}
