<?php
abstract class PrihlaseniZakaznik
{
	private static $zakaznik = null;  // instance prihlaseneho zakaznika
	
	
	public static  function kontrolaRelacePrihlaseni()
	{					
			
		try
		{						
			//kontrola, jestli je uživatel přihlášen a nebyl příliš dlouho neaktivní
			if (isset($_SESSION['zakaznik']['id']))			
			{	
				if (($_SESSION['zakaznik']['posledniAktivita'] + __DOBA_AUTOMATICKEHO_ODHLASENI__) < time())
				{
					self::odhlasit(); //byl překročen časový limit -> odhlásit
					return false;
				}
				self::$zakaznik = N::Zakaznik($_SESSION['zakaznik']['id']);
			}
		}
		catch(Chyba $e)
		{
			self::odhlasit();
		}
		 
	}
	
	/**
	 * Porovná předaný email a heslo s uádaji v databázi
	 * při úspěchu přihlásit
	 * @param ustring $email
	 * @param string $heslo
	 * @throws Chyba
	 */
	public static function kontrolaPrihlasovacichUdaju($email,$heslo)
	{
		Validace::delka($heslo,6,20,'Heslo');
		Validace::email($email);
		$parametry = array("email"=>$email);
		$dotaz = "SELECT id_zakaznik,heslo FROM zakaznik WHERE email = :email LIMIT 1";
		$radek = DB::dotazJeden($dotaz,$parametry);
		if (!$radek or !password_verify($heslo, $radek["heslo"]))
		{
			throw new Chyba('Neplatný e-mail nebo heslo.');
		}
		self::$zakaznik = N::Zakaznik($radek['id_zakaznik']);
		self::prihlasit();
	}
		 
	private static function  prihlasit()
	{		 
		if (self::$zakaznik)
		{		
			$_SESSION['zakaznik'] =  self::$zakaznik->zobraz();
			$_SESSION['zakaznik']['posledniAktivita'] = Time();
		}		 
	}
	
	/**
	 * Ruší session a coookies a přesměrovává na login
	 * při volání odhlásit se nezobrazí předchozí chybová hlášení uložené v session
	 */
	public static function  odhlasit()
	{
		//zachovat vyjimky
		//neničit session - jsou v ní hlášení
		$vyjimka = isset($_SESSION['vyjimka']) ? $_SESSION['vyjimka'] : null;
		$_SESSION = array();
		$_SESSION['vyjimka'] = $vyjimka;
		//neničit sessio - jsou v ní hlášení
		
	    /*setcookie (session_name(), '', time()-300, '/', '', 0);
		session_destroy();
		FK::presmerovat(__WEB__."login") ;*/
	}
	
	public static function vratZakaznika()
	{
		return self::$zakaznik;
	}
}
