<?php

class SkupinaPokoju Extends BO2
 {
  
  protected $id = null;
  protected $nazev = null;
  protected $cenaZaLuzko = null;
  protected $cenaZaPokoj = null;
  protected $pocetLuzek = null;  
  protected $typ = null;
  protected $penaleZaNeobsazene = null;
  protected $minOsob = null;
 
  protected $pokoje = null;
  
  protected static $kolekce;
   
  protected static $tabulkaDB = "skupina_pokoju";
  protected static $mapovaniDB = array ( 
   "id" => "id_skupina_pokoju",
   "nazev" => "nazev",
   "cenaZaLuzko"  => "cena_za_luzko",
   "cenaZaPokoj" => "cena_za_pokoj",
   "pocetLuzek" => "pocet_luzek",
   "minOsob" => "min_osob",
   "penaleZaNeobsazene" => "penale_za_neobsazene",
     );
  		
  function __construct($id=null)
	{  			
		parent::__construct($id);
      
    $this->pokoje = new Kolekce('Pokoj');
   	$this->pokoje->nastavCallback('kolekceSouvisejicich', $this);
	}	
	

	public function nastavCenaZaluzko($prom)
	{		
		Validace::numeric($prom,"Cena za lůžko",$nastaveni = array("min" => 0));
		$this->cenaZaLuzko = $prom;
	}
	public function nastavCenaZaPokoj($prom)
	{
		Validace::numeric($prom,"Cena za pokoj",$nastaveni = array("min" => 0));
		$this->cenaZaPokoj = $prom;
	}
	public function nastavPocetLuzek($prom)
	{
		Validace::integer($prom,"Počet lůžek",$nastaveni = array("min" => 1));
		$this->pocetLuzek = $prom;
	}
	public function nastavMinOsob($prom)
	{
		Validace::integer($prom,"Minimum osob",$nastaveni = array("min" => 1));
		$this->minOsob = $prom;
	}
	public function nastavPenaleZaNeobsazene($prom)
	{
		Validace::integer($prom,"Penále za neobsazené lůžko",$nastaveni = array("min" => 0));
		$this->penaleZaNeobsazene = $prom;
	}
	public function nastavNazev($prom)
	{
		Validace::delka($prom, 1, 50, "Název");
		$this->nazev = $prom;
	}
	
  

	
  public function vratCenaZaNoc($pocetHostu)
  {  	
  	$cena = $this->cenaZaPokoj + (($this->cenaZaLuzko * $pocetHostu) + (($this->pocetLuzek - $pocetHostu) * $this->penaleZaNeobsazene));
  	return $cena;  	
  } 	
	
 
}