<?php
class Sluzba extends BO2
{
protected $id = null;
	protected $nazev = null;
	protected $rezervaceId = null;
	protected $pocetDnu = null;	
	protected $cenaJednotkova= null;
	protected $mnozstvi= null;

	protected static $kolekce;	
	
	protected static $tabulkaDB = "sluzba_rezervace";
	protected static $mapovaniDB = array (
			"id" => "id_sluzba",
			"rezervaceId" => "id_rezervace",
			"pocetDnu" => "pocet_dnu",
			"cenaJednotkova" => "cena",
			"nazev" => "nazev",
			"mnozstvi" => "mnozstvi",
	);
	
	

	function __construct($id=null)
	{
		parent::__construct($id);
	}
	
	public function nastavRezervaceId($prom)
	{			
		N::Rezervace($prom)->kontrolaId();		
		$this->rezervaceId = $prom;
	}
	
	public function nastavNazev($prom)
	{
		Validace::delka($prom, 1, 255, "Název");
		$this->nazev = $prom;
	}
	
	public function nastavPocetDni($prom)
	{		
		Validace::integer($prom,"Počet",$nastaveni = array("min" => 1, "povinny" => true));			
		$this->pocetDni = $prom;
	}
	
	public function nastavMnozstvi($prom)
	{
		Validace::integer($prom,"Množství",$nastaveni = array("min" => 1, "povinny" => true));
		$this->mnozstvi = $prom;
	}
	
	public function nastavCenaJednotkova($prom)
	{
		Validace::numeric($prom,"Cena",$nastaveni = array("min" => 0, "povinny" => true));		
		$this->cenaJednotkova = $prom;
	}	
	
	public function vratCenaCelkem()
	{
		return $this->pocetDnu * $this->cenaJednotkova * $this->mnozstvi;
	}
}