<?php
class StavRezervace extends BO2
{
	protected $id = null;
	protected $rezervaceId = null;	
	protected $cas = null;
	protected $stavId = null;
	protected $poznamka = null;

	protected static $kolekce;
	protected static $stavy = array (1 => "Nová",  2=> "Schválená", 3 => "Zaplacená", 10 =>"Stornovaná" );
			
	protected static $tabulkaDB = "stav_rezervace";
	protected static $mapovaniDB = array (
			"id" => "id_stav_rezervace",
			"rezervaceId" => "id_rezervace",
			"stavId" => "id_stav",
			"cas" => "cas",
			"poznamka" => "poznamka"
	);
	
	
	

	function __construct($id=null)
	{
		parent::__construct($id);
	}
	
	public function nastavRezervaceId($prom)
	{			
		N::Rezervace($prom)->kontrolaId();		
		$this->rezervaceId = $prom;
	}
	
	public  function nastavStavId($stavId)
	{
		self::existujeStav($stavId);
		$this->stavId = $stavId;
	}
	
	public function nastavCas($prom)
	{		
		Validace::datum($prom,"d.m.Y H:i:s");
		$prom = DateTime::createFromFormat("d.m.Y H:i:s",$prom);		
		$this->cas = $prom->format("Y-m-d H:i:s");
	}
	
	public function nastavPoznamka($prom)
	{
		Validace::delka($prom, 0, 500, "Poznámka");
		$this->poznamka = $prom;
	}
				
	
	public function vratStav()
	{	
		if (!isset(self::$stavy[$this->stavId]))
		{
			return "Neznámý";
		}
		return self::$stavy[$this->stavId];
		
	}
	
		
	public static function existujeStav($stavId)
	{	
		if (!isset(self::$stavy[$stavId]))
		{
			throw new Chyba ("Tento stav $stavId neexistuje");
		}
	}
	
	public function ulozit()
	{
		if (!$this->cas)
		{
			$cas = new Datetime();
			$this->cas = $cas->format("Y-m-d H:i:s");
		}
		parent::ulozit();
		
	}
	
	
}