<?php

class Strava Extends BO2
 {
  
  protected $id = null;
  protected $stravaId = null;
  protected $rezervaceId = null; 
  protected $pocet = null;
  protected $cenaJednotkova = null;
  
  protected $rezervace = null; 
  
  protected static $kolekce;
  
  //při změne typu nezapomenou upravit nastavení cen viz metoda vratStravaCeny()
  protected static $stravaTypy = array (1=>"Dospělí - plná penze", 2=>"Dospělí - polopenze", 3=>"Děti - plná penze", 4=>"Děti - polopenze");
  protected static $stravaCeny = array (); 		
 
  
  protected static $tabulkaDB = "strava_rezervace";
  protected static $mapovaniDB = array ( 
   "id" => "id_strava_rezervace",
   "stravaId" => "id_strava",
   "rezervaceId"  => "id_rezervace",
   "pocet" => "pocet",
   "cenaJednotkova" => "cena_jednotkova"    
   );
  
		
	public function __construct($id=null)
	{  		
		parent::__construct($id);
	}	
  
 
  public function nastavStravaId($id)	
  {
  	self::vratStravaCeny();
  	if (!isset(self::$stravaTypy[$id]) or !isset(self::$stravaCeny[$id]))
  	throw new Chyba ("Tento typ stravy neexistuje");
  	$this->stravaId = $id;
  	$this->cenaJednotkova =  self::$stravaCeny[$id];
  }
  
  public function nastavPocet($prom)
  {
  	Validace::integer($prom,"Cena dobropisu",$nastaveni = array("min" => 1,"povinny" => true));
  	$this->pocet = $prom;  	
   }
	
   
  public function vratCelkovaCenaDen()
   {
   	 return $this->cenaJednotkova *  $this->pocet;
   } 
   
   public function vratTyp()
   {
   	return self::$stravaTypy[$this->stravaId];
   }   
   
   public static function vratStravaCeny()
   {
   	if (!self::$stravaCeny)
   	{
   		self::$stravaCeny[1] = N::Nastaveni("stravaDospeliPlnaPenzeCena")->vratHodnota();
   		self::$stravaCeny[2] = N::Nastaveni("stravaDospeliPolopenzeCena")->vratHodnota();
   		self::$stravaCeny[3] = N::Nastaveni("stravaDetiPlnaPenzeCena")->vratHodnota();
   		self::$stravaCeny[4] = N::Nastaveni("stravaDetiPolopenzeCena")->vratHodnota();   		
   	}
   	return self::$stravaCeny;
   } 
   
  
  
  
  
  
}
